! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.2.1_rs5 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : SUAQ_messy_mecca_kpp_Jacobian.f90
! Time                 : Tue Jan 23 13:18:01 2018
! Working directory    : /gpfs/projects/bsc32/bsc32771/MN3/NMMB/test/KPP/caaba_3.0gmdd/mecca
! Equation file        : SUAQ_messy_mecca_kpp.kpp
! Output root filename : SUAQ_messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE SUAQ_messy_mecca_kpp_Jacobian

  USE SUAQ_messy_mecca_kpp_Parameters
  USE SUAQ_messy_mecca_kpp_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP - the Jacobian of Variables in sparse matrix representation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      JVS       - sparse Jacobian of variables
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP ( V, F, RCT, JVS )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)


! Local variables
! B - Temporary array
  REAL(kind=dp) :: B(23)

! B(1) = dA(1)/dV(2)
  B(1) = RCT(1)*F(1)
! B(3) = dA(2)/dV(2)
  B(3) = RCT(2)*F(1)
! B(5) = dA(3)/dV(1)
  B(5) = RCT(3)
! B(6) = dA(4)/dV(14)
  B(6) = RCT(4)*V(15)
! B(7) = dA(4)/dV(15)
  B(7) = RCT(4)*V(14)
! B(8) = dA(5)/dV(13)
  B(8) = RCT(5)*V(15)
! B(9) = dA(5)/dV(15)
  B(9) = RCT(5)*V(13)
! B(10) = dA(6)/dV(10)
  B(10) = RCT(6)*V(13)
! B(11) = dA(6)/dV(13)
  B(11) = RCT(6)*V(10)
! B(12) = dA(7)/dV(7)
  B(12) = RCT(7)
! B(13) = dA(8)/dV(15)
  B(13) = RCT(8)
! B(14) = dA(9)/dV(9)
  B(14) = RCT(9)
! B(15) = dA(10)/dV(10)
  B(15) = RCT(10)
! B(16) = dA(11)/dV(8)
  B(16) = RCT(11)
! B(17) = dA(12)/dV(11)
  B(17) = RCT(12)
! B(18) = dA(13)/dV(11)
  B(18) = RCT(13)
! B(19) = dA(14)/dV(12)
  B(19) = RCT(14)*V(13)
! B(20) = dA(14)/dV(13)
  B(20) = RCT(14)*V(12)
! B(21) = dA(15)/dV(13)
  B(21) = RCT(15)
! B(22) = dA(16)/dV(12)
  B(22) = RCT(16)*V(14)
! B(23) = dA(16)/dV(14)
  B(23) = RCT(16)*V(12)

! Construct the Jacobian terms from B's
! JVS(1) = Jac_FULL(1,1)
  JVS(1) = -B(5)
! JVS(2) = Jac_FULL(2,2)
  JVS(2) = -B(1)-B(3)
! JVS(3) = Jac_FULL(3,2)
  JVS(3) = 0.5*B(3)
! JVS(4) = Jac_FULL(3,3)
  JVS(4) = 0
! JVS(5) = Jac_FULL(4,1)
  JVS(5) = 2*B(5)
! JVS(6) = Jac_FULL(4,4)
  JVS(6) = 0
! JVS(7) = Jac_FULL(5,1)
  JVS(7) = 2*B(5)
! JVS(8) = Jac_FULL(5,5)
  JVS(8) = 0
! JVS(9) = Jac_FULL(6,6)
  JVS(9) = 0
! JVS(10) = Jac_FULL(6,10)
  JVS(10) = B(10)
! JVS(11) = Jac_FULL(6,13)
  JVS(11) = B(8)+B(11)
! JVS(12) = Jac_FULL(6,14)
  JVS(12) = B(6)
! JVS(13) = Jac_FULL(6,15)
  JVS(13) = B(7)+B(9)
! JVS(14) = Jac_FULL(7,7)
  JVS(14) = -B(12)
! JVS(15) = Jac_FULL(7,15)
  JVS(15) = B(13)
! JVS(16) = Jac_FULL(8,2)
  JVS(16) = B(1)+0.5*B(3)
! JVS(17) = Jac_FULL(8,8)
  JVS(17) = -B(16)
! JVS(18) = Jac_FULL(8,11)
  JVS(18) = B(17)
! JVS(19) = Jac_FULL(9,9)
  JVS(19) = -B(14)
! JVS(20) = Jac_FULL(9,10)
  JVS(20) = B(15)
! JVS(21) = Jac_FULL(10,9)
  JVS(21) = B(14)
! JVS(22) = Jac_FULL(10,10)
  JVS(22) = -B(10)-B(15)
! JVS(23) = Jac_FULL(10,13)
  JVS(23) = -B(11)
! JVS(24) = Jac_FULL(11,8)
  JVS(24) = B(16)
! JVS(25) = Jac_FULL(11,11)
  JVS(25) = -B(17)-B(18)
! JVS(26) = Jac_FULL(11,12)
  JVS(26) = B(19)
! JVS(27) = Jac_FULL(11,13)
  JVS(27) = B(20)
! JVS(28) = Jac_FULL(12,10)
  JVS(28) = B(10)
! JVS(29) = Jac_FULL(12,11)
  JVS(29) = B(18)
! JVS(30) = Jac_FULL(12,12)
  JVS(30) = -B(19)-B(22)
! JVS(31) = Jac_FULL(12,13)
  JVS(31) = B(8)+B(11)-B(20)+B(21)
! JVS(32) = Jac_FULL(12,14)
  JVS(32) = -B(23)
! JVS(33) = Jac_FULL(12,15)
  JVS(33) = B(9)
! JVS(34) = Jac_FULL(13,10)
  JVS(34) = -B(10)
! JVS(35) = Jac_FULL(13,11)
  JVS(35) = B(18)
! JVS(36) = Jac_FULL(13,12)
  JVS(36) = -B(19)+B(22)
! JVS(37) = Jac_FULL(13,13)
  JVS(37) = -B(8)-B(11)-B(20)-B(21)
! JVS(38) = Jac_FULL(13,14)
  JVS(38) = B(23)
! JVS(39) = Jac_FULL(13,15)
  JVS(39) = -B(9)
! JVS(40) = Jac_FULL(14,12)
  JVS(40) = -B(22)
! JVS(41) = Jac_FULL(14,13)
  JVS(41) = B(21)
! JVS(42) = Jac_FULL(14,14)
  JVS(42) = -B(6)-B(23)
! JVS(43) = Jac_FULL(14,15)
  JVS(43) = -B(7)
! JVS(44) = Jac_FULL(15,7)
  JVS(44) = B(12)
! JVS(45) = Jac_FULL(15,13)
  JVS(45) = -B(8)
! JVS(46) = Jac_FULL(15,14)
  JVS(46) = -B(6)
! JVS(47) = Jac_FULL(15,15)
  JVS(47) = -B(7)-B(9)-B(13)
      
END SUBROUTINE Jac_SP

! End of Jac_SP function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR)

  JUV(1) = JVS(1)*UV(1)
  JUV(2) = JVS(2)*UV(2)
  JUV(3) = JVS(3)*UV(2)+JVS(4)*UV(3)
  JUV(4) = JVS(5)*UV(1)+JVS(6)*UV(4)
  JUV(5) = JVS(7)*UV(1)+JVS(8)*UV(5)
  JUV(6) = JVS(9)*UV(6)+JVS(10)*UV(10)+JVS(11)*UV(13)+JVS(12)*UV(14)+JVS(13)*UV(15)
  JUV(7) = JVS(14)*UV(7)+JVS(15)*UV(15)
  JUV(8) = JVS(16)*UV(2)+JVS(17)*UV(8)+JVS(18)*UV(11)
  JUV(9) = JVS(19)*UV(9)+JVS(20)*UV(10)
  JUV(10) = JVS(21)*UV(9)+JVS(22)*UV(10)+JVS(23)*UV(13)
  JUV(11) = JVS(24)*UV(8)+JVS(25)*UV(11)+JVS(26)*UV(12)+JVS(27)*UV(13)
  JUV(12) = JVS(28)*UV(10)+JVS(29)*UV(11)+JVS(30)*UV(12)+JVS(31)*UV(13)+JVS(32)*UV(14)+JVS(33)*UV(15)
  JUV(13) = JVS(34)*UV(10)+JVS(35)*UV(11)+JVS(36)*UV(12)+JVS(37)*UV(13)+JVS(38)*UV(14)+JVS(39)*UV(15)
  JUV(14) = JVS(40)*UV(12)+JVS(41)*UV(13)+JVS(42)*UV(14)+JVS(43)*UV(15)
  JUV(15) = JVS(44)*UV(7)+JVS(45)*UV(13)+JVS(46)*UV(14)+JVS(47)*UV(15)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR)

  JTUV(1) = JVS(1)*UV(1)+JVS(5)*UV(4)+JVS(7)*UV(5)
  JTUV(2) = JVS(2)*UV(2)+JVS(3)*UV(3)+JVS(16)*UV(8)
  JTUV(3) = JVS(4)*UV(3)
  JTUV(4) = JVS(6)*UV(4)
  JTUV(5) = JVS(8)*UV(5)
  JTUV(6) = JVS(9)*UV(6)
  JTUV(7) = JVS(14)*UV(7)+JVS(44)*UV(15)
  JTUV(8) = JVS(17)*UV(8)+JVS(24)*UV(11)
  JTUV(9) = JVS(19)*UV(9)+JVS(21)*UV(10)
  JTUV(10) = JVS(10)*UV(6)+JVS(20)*UV(9)+JVS(22)*UV(10)+JVS(28)*UV(12)+JVS(34)*UV(13)
  JTUV(11) = JVS(18)*UV(8)+JVS(25)*UV(11)+JVS(29)*UV(12)+JVS(35)*UV(13)
  JTUV(12) = JVS(26)*UV(11)+JVS(30)*UV(12)+JVS(36)*UV(13)+JVS(40)*UV(14)
  JTUV(13) = JVS(11)*UV(6)+JVS(23)*UV(10)+JVS(27)*UV(11)+JVS(31)*UV(12)+JVS(37)*UV(13)+JVS(41)*UV(14)+JVS(45)*UV(15)
  JTUV(14) = JVS(12)*UV(6)+JVS(32)*UV(12)+JVS(38)*UV(13)+JVS(42)*UV(14)+JVS(46)*UV(15)
  JTUV(15) = JVS(13)*UV(6)+JVS(15)*UV(7)+JVS(33)*UV(12)+JVS(39)*UV(13)+JVS(43)*UV(14)+JVS(47)*UV(15)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE SUAQ_messy_mecca_kpp_Jacobian

