! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The ODE Jacobian of Chemical Model File
! 
! Generated by KPP-2.2.1_rs5 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : messy_mecca_kpp_Jacobian.f90
! Time                 : Sun Dec 21 18:36:06 2014
! Working directory    : /.statelite/tmpfs/gpfs/projects/bsc32/bsc32771/MN3/NMMB/test/KPP/caaba_3.0gmdd/mecca
! Equation file        : messy_mecca_kpp.kpp
! Output root filename : messy_mecca_kpp
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE messy_mecca_kpp_Jacobian

  USE messy_mecca_kpp_Parameters
  USE messy_mecca_kpp_JacobianSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP - the Jacobian of Variables in sparse matrix representation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      RCT       - Rate constants (local)
!      JVS       - sparse Jacobian of variables
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP ( V, F, RCT, JVS )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! RCT - Rate constants (local)
  REAL(kind=dp) :: RCT(NREACT)
! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)


! Local variables
! B - Temporary array
  REAL(kind=dp) :: B(28)

! B(2) = dA(2)/dV(6)
  B(2) = 1.8e-12*F(3)
! B(4) = dA(3)/dV(5)
  B(4) = RCT(3)*F(3)
! B(6) = dA(4)/dV(6)
  B(6) = RCT(4)
! B(7) = dA(5)/dV(1)
  B(7) = RCT(5)*F(3)
! B(9) = dA(6)/dV(1)
  B(9) = RCT(6)*F(3)
! B(11) = dA(7)/dV(11)
  B(11) = RCT(7)*V(12)
! B(12) = dA(7)/dV(12)
  B(12) = RCT(7)*V(11)
! B(13) = dA(8)/dV(10)
  B(13) = RCT(8)*V(12)
! B(14) = dA(8)/dV(12)
  B(14) = RCT(8)*V(10)
! B(15) = dA(9)/dV(7)
  B(15) = RCT(9)*V(10)
! B(16) = dA(9)/dV(10)
  B(16) = RCT(9)*V(7)
! B(18) = dA(11)/dV(12)
  B(18) = RCT(11)
! B(19) = dA(12)/dV(6)
  B(19) = RCT(12)
! B(20) = dA(13)/dV(7)
  B(20) = RCT(13)
! B(21) = dA(14)/dV(5)
  B(21) = RCT(14)
! B(22) = dA(15)/dV(8)
  B(22) = RCT(15)
! B(23) = dA(16)/dV(8)
  B(23) = RCT(16)
! B(24) = dA(17)/dV(9)
  B(24) = RCT(17)*V(10)
! B(25) = dA(17)/dV(10)
  B(25) = RCT(17)*V(9)
! B(26) = dA(18)/dV(10)
  B(26) = RCT(18)
! B(27) = dA(19)/dV(9)
  B(27) = RCT(19)*V(11)
! B(28) = dA(19)/dV(11)
  B(28) = RCT(19)*V(9)

! Construct the Jacobian terms from B's
! JVS(1) = Jac_FULL(1,1)
  JVS(1) = -B(7)-B(9)
! JVS(2) = Jac_FULL(2,2)
  JVS(2) = 0
! JVS(3) = Jac_FULL(2,6)
  JVS(3) = B(2)
! JVS(4) = Jac_FULL(3,3)
  JVS(4) = 0
! JVS(5) = Jac_FULL(3,5)
  JVS(5) = B(4)
! JVS(6) = Jac_FULL(4,4)
  JVS(6) = 0
! JVS(7) = Jac_FULL(4,7)
  JVS(7) = B(15)
! JVS(8) = Jac_FULL(4,10)
  JVS(8) = B(13)+B(16)
! JVS(9) = Jac_FULL(4,11)
  JVS(9) = B(11)
! JVS(10) = Jac_FULL(4,12)
  JVS(10) = B(12)+B(14)
! JVS(11) = Jac_FULL(5,1)
  JVS(11) = B(7)+0.5*B(9)
! JVS(12) = Jac_FULL(5,5)
  JVS(12) = -B(4)-B(21)
! JVS(13) = Jac_FULL(5,8)
  JVS(13) = B(22)
! JVS(14) = Jac_FULL(6,6)
  JVS(14) = -B(2)-B(6)-B(19)
! JVS(15) = Jac_FULL(6,7)
  JVS(15) = B(20)
! JVS(16) = Jac_FULL(7,6)
  JVS(16) = B(19)
! JVS(17) = Jac_FULL(7,7)
  JVS(17) = -B(15)-B(20)
! JVS(18) = Jac_FULL(7,10)
  JVS(18) = -B(16)
! JVS(19) = Jac_FULL(8,5)
  JVS(19) = B(21)
! JVS(20) = Jac_FULL(8,8)
  JVS(20) = -B(22)-B(23)
! JVS(21) = Jac_FULL(8,9)
  JVS(21) = B(24)
! JVS(22) = Jac_FULL(8,10)
  JVS(22) = B(25)
! JVS(23) = Jac_FULL(9,7)
  JVS(23) = B(15)
! JVS(24) = Jac_FULL(9,8)
  JVS(24) = B(23)
! JVS(25) = Jac_FULL(9,9)
  JVS(25) = -B(24)-B(27)
! JVS(26) = Jac_FULL(9,10)
  JVS(26) = B(13)+B(16)-B(25)+B(26)
! JVS(27) = Jac_FULL(9,11)
  JVS(27) = -B(28)
! JVS(28) = Jac_FULL(9,12)
  JVS(28) = B(14)
! JVS(29) = Jac_FULL(10,7)
  JVS(29) = -B(15)
! JVS(30) = Jac_FULL(10,8)
  JVS(30) = B(23)
! JVS(31) = Jac_FULL(10,9)
  JVS(31) = -B(24)+B(27)
! JVS(32) = Jac_FULL(10,10)
  JVS(32) = -B(13)-B(16)-B(25)-B(26)
! JVS(33) = Jac_FULL(10,11)
  JVS(33) = B(28)
! JVS(34) = Jac_FULL(10,12)
  JVS(34) = -B(14)
! JVS(35) = Jac_FULL(11,9)
  JVS(35) = -B(27)
! JVS(36) = Jac_FULL(11,10)
  JVS(36) = B(26)
! JVS(37) = Jac_FULL(11,11)
  JVS(37) = -B(11)-B(28)
! JVS(38) = Jac_FULL(11,12)
  JVS(38) = -B(12)
! JVS(39) = Jac_FULL(12,10)
  JVS(39) = -B(13)
! JVS(40) = Jac_FULL(12,11)
  JVS(40) = -B(11)
! JVS(41) = Jac_FULL(12,12)
  JVS(41) = -B(12)-B(14)-B(18)
      
END SUBROUTINE Jac_SP

! End of Jac_SP function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Jac_SP_Vec - function for sparse multiplication: sparse Jacobian times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JUV       - Jacobian times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE Jac_SP_Vec ( JVS, UV, JUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JUV - Jacobian times user vector
  REAL(kind=dp) :: JUV(NVAR)

  JUV(1) = JVS(1)*UV(1)
  JUV(2) = JVS(2)*UV(2)+JVS(3)*UV(6)
  JUV(3) = JVS(4)*UV(3)+JVS(5)*UV(5)
  JUV(4) = JVS(6)*UV(4)+JVS(7)*UV(7)+JVS(8)*UV(10)+JVS(9)*UV(11)+JVS(10)*UV(12)
  JUV(5) = JVS(11)*UV(1)+JVS(12)*UV(5)+JVS(13)*UV(8)
  JUV(6) = JVS(14)*UV(6)+JVS(15)*UV(7)
  JUV(7) = JVS(16)*UV(6)+JVS(17)*UV(7)+JVS(18)*UV(10)
  JUV(8) = JVS(19)*UV(5)+JVS(20)*UV(8)+JVS(21)*UV(9)+JVS(22)*UV(10)
  JUV(9) = JVS(23)*UV(7)+JVS(24)*UV(8)+JVS(25)*UV(9)+JVS(26)*UV(10)+JVS(27)*UV(11)+JVS(28)*UV(12)
  JUV(10) = JVS(29)*UV(7)+JVS(30)*UV(8)+JVS(31)*UV(9)+JVS(32)*UV(10)+JVS(33)*UV(11)+JVS(34)*UV(12)
  JUV(11) = JVS(35)*UV(9)+JVS(36)*UV(10)+JVS(37)*UV(11)+JVS(38)*UV(12)
  JUV(12) = JVS(39)*UV(10)+JVS(40)*UV(11)+JVS(41)*UV(12)
      
END SUBROUTINE Jac_SP_Vec

! End of Jac_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacTR_SP_Vec - sparse multiplication: sparse Jacobian transposed times vector
!   Arguments :
!      JVS       - sparse Jacobian of variables
!      UV        - User vector for variables
!      JTUV      - Jacobian transposed times user vector
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacTR_SP_Vec ( JVS, UV, JTUV )

! JVS - sparse Jacobian of variables
  REAL(kind=dp) :: JVS(LU_NONZERO)
! UV - User vector for variables
  REAL(kind=dp) :: UV(NVAR)
! JTUV - Jacobian transposed times user vector
  REAL(kind=dp) :: JTUV(NVAR)

  JTUV(1) = JVS(1)*UV(1)+JVS(11)*UV(5)
  JTUV(2) = JVS(2)*UV(2)
  JTUV(3) = JVS(4)*UV(3)
  JTUV(4) = JVS(6)*UV(4)
  JTUV(5) = JVS(5)*UV(3)+JVS(12)*UV(5)+JVS(19)*UV(8)
  JTUV(6) = JVS(3)*UV(2)+JVS(14)*UV(6)+JVS(16)*UV(7)
  JTUV(7) = JVS(7)*UV(4)+JVS(15)*UV(6)+JVS(17)*UV(7)+JVS(23)*UV(9)+JVS(29)*UV(10)
  JTUV(8) = JVS(13)*UV(5)+JVS(20)*UV(8)+JVS(24)*UV(9)+JVS(30)*UV(10)
  JTUV(9) = JVS(21)*UV(8)+JVS(25)*UV(9)+JVS(31)*UV(10)+JVS(35)*UV(11)
  JTUV(10) = JVS(8)*UV(4)+JVS(18)*UV(7)+JVS(22)*UV(8)+JVS(26)*UV(9)+JVS(32)*UV(10)+JVS(36)*UV(11)+JVS(39)*UV(12)
  JTUV(11) = JVS(9)*UV(4)+JVS(27)*UV(9)+JVS(33)*UV(10)+JVS(37)*UV(11)+JVS(40)*UV(12)
  JTUV(12) = JVS(10)*UV(4)+JVS(28)*UV(9)+JVS(34)*UV(10)+JVS(38)*UV(11)+JVS(41)*UV(12)
      
END SUBROUTINE JacTR_SP_Vec

! End of JacTR_SP_Vec function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



END MODULE messy_mecca_kpp_Jacobian

