! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! Parameter Module File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cbm5_Parameters.f90
! Time                 : Fri Jan 29 14:37:03 2010
! Working directory    : /gpfs/projects/bsc32/bsc32771/UMO/UMO-Chem/chemistry/KPP/kpp-2.2.1.December2006/models/CBM5
! Equation file        : cbm5.kpp
! Output root filename : cbm5
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cbm5_Parameters

  USE cbm5_Precision
  PUBLIC
  SAVE


! NSPEC - Number of chemical species
  INTEGER, PARAMETER :: NSPEC = 56 
! NVAR - Number of Variable species
  INTEGER, PARAMETER :: NVAR = 51 
! NVARACT - Number of Active species
  INTEGER, PARAMETER :: NVARACT = 50 
! NFIX - Number of Fixed species
  INTEGER, PARAMETER :: NFIX = 5 
! NREACT - Number of reactions
  INTEGER, PARAMETER :: NREACT = 156 
! NVARST - Starting of variables in conc. vect.
  INTEGER, PARAMETER :: NVARST = 1 
! NFIXST - Starting of fixed in conc. vect.
  INTEGER, PARAMETER :: NFIXST = 52 
! NONZERO - Number of nonzero entries in Jacobian
  INTEGER, PARAMETER :: NONZERO = 520 
! LU_NONZERO - Number of nonzero entries in LU factoriz. of Jacobian
  INTEGER, PARAMETER :: LU_NONZERO = 580 
! CNVAR - (NVAR+1) Number of elements in compressed row format
  INTEGER, PARAMETER :: CNVAR = 52 
! CNEQN - (NREACT+1) Number stoicm elements in compressed col format
  INTEGER, PARAMETER :: CNEQN = 157 
! NHESS - Length of Sparse Hessian
  INTEGER, PARAMETER :: NHESS = 548 
! NLOOKAT - Number of species to look at
  INTEGER, PARAMETER :: NLOOKAT = 56 
! NMONITOR - Number of species to monitor
  INTEGER, PARAMETER :: NMONITOR = 1 
! NMASS - Number of atoms to check mass balance
  INTEGER, PARAMETER :: NMASS = 1 

! Index declaration for variable species in C and VAR
!   VAR(ind_spc) = C(ind_spc)

  INTEGER, PARAMETER :: ind_SULF = 1 
  INTEGER, PARAMETER :: ind_SO2 = 2 
  INTEGER, PARAMETER :: ind_O1D = 3 
  INTEGER, PARAMETER :: ind_PAN = 4 
  INTEGER, PARAMETER :: ind_TOL = 5 
  INTEGER, PARAMETER :: ind_ETHA = 6 
  INTEGER, PARAMETER :: ind_MEOH = 7 
  INTEGER, PARAMETER :: ind_N2O5 = 8 
  INTEGER, PARAMETER :: ind_ETOH = 9 
  INTEGER, PARAMETER :: ind_XYL = 10 
  INTEGER, PARAMETER :: ind_HONO = 11 
  INTEGER, PARAMETER :: ind_H2O2 = 12 
  INTEGER, PARAMETER :: ind_FACD = 13 
  INTEGER, PARAMETER :: ind_PACD = 14 
  INTEGER, PARAMETER :: ind_AACD = 15 
  INTEGER, PARAMETER :: ind_PANX = 16 
  INTEGER, PARAMETER :: ind_PNA = 17 
  INTEGER, PARAMETER :: ind_TO2 = 18 
  INTEGER, PARAMETER :: ind_HCO3 = 19 
  INTEGER, PARAMETER :: ind_MGLY = 20 
  INTEGER, PARAMETER :: ind_ROOH = 21 
  INTEGER, PARAMETER :: ind_CRO = 22 
  INTEGER, PARAMETER :: ind_ROR = 23 
  INTEGER, PARAMETER :: ind_MEPX = 24 
  INTEGER, PARAMETER :: ind_CO = 25 
  INTEGER, PARAMETER :: ind_OPEN = 26 
  INTEGER, PARAMETER :: ind_HNO3 = 27 
  INTEGER, PARAMETER :: ind_ETH = 28 
  INTEGER, PARAMETER :: ind_IOLE = 29 
  INTEGER, PARAMETER :: ind_OLE = 30 
  INTEGER, PARAMETER :: ind_CRES = 31 
  INTEGER, PARAMETER :: ind_TERP = 32 
  INTEGER, PARAMETER :: ind_PAR = 33 
  INTEGER, PARAMETER :: ind_ISOP = 34 
  INTEGER, PARAMETER :: ind_ISPD = 35 
  INTEGER, PARAMETER :: ind_XO2N = 36 
  INTEGER, PARAMETER :: ind_ALDX = 37 
  INTEGER, PARAMETER :: ind_ALD2 = 38 
  INTEGER, PARAMETER :: ind_FORM = 39 
  INTEGER, PARAMETER :: ind_NTR = 40 
  INTEGER, PARAMETER :: ind_O3 = 41 
  INTEGER, PARAMETER :: ind_XO2 = 42 
  INTEGER, PARAMETER :: ind_HO2 = 43 
  INTEGER, PARAMETER :: ind_MEO2 = 44 
  INTEGER, PARAMETER :: ind_O = 45 
  INTEGER, PARAMETER :: ind_C2O3 = 46 
  INTEGER, PARAMETER :: ind_CXO3 = 47 
  INTEGER, PARAMETER :: ind_OH = 48 
  INTEGER, PARAMETER :: ind_NO3 = 49 
  INTEGER, PARAMETER :: ind_NO = 50 
  INTEGER, PARAMETER :: ind_NO2 = 51 

! Index declaration for fixed species in C
!   C(ind_spc)

  INTEGER, PARAMETER :: ind_H2O = 52 
  INTEGER, PARAMETER :: ind_H2 = 53 
  INTEGER, PARAMETER :: ind_O2 = 54 
  INTEGER, PARAMETER :: ind_CH4 = 55 
  INTEGER, PARAMETER :: ind_M = 56 

! Index declaration for fixed species in FIX
!    FIX(indf_spc) = C(ind_spc) = C(NVAR+indf_spc)

  INTEGER, PARAMETER :: indf_H2O = 1 
  INTEGER, PARAMETER :: indf_H2 = 2 
  INTEGER, PARAMETER :: indf_O2 = 3 
  INTEGER, PARAMETER :: indf_CH4 = 4 
  INTEGER, PARAMETER :: indf_M = 5 

! NJVRP - Length of sparse Jacobian JVRP
  INTEGER, PARAMETER :: NJVRP = 261 

! NSTOICM - Length of Sparse Stoichiometric Matrix
  INTEGER, PARAMETER :: NSTOICM = 680 

END MODULE cbm5_Parameters

