! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! The Stoichiometric Chemical Model File
! 
! Generated by KPP-2.2 symbolic chemistry Kinetics PreProcessor
!       (http://www.cs.vt.edu/~asandu/Software/KPP)
! KPP is distributed under GPL, the general public licence
!       (http://www.gnu.org/copyleft/gpl.html)
! (C) 1995-1997, V. Damian & A. Sandu, CGRER, Univ. Iowa
! (C) 1997-2005, A. Sandu, Michigan Tech, Virginia Tech
!     With important contributions from:
!        M. Damian, Villanova University, USA
!        R. Sander, Max-Planck Institute for Chemistry, Mainz, Germany
! 
! File                 : cbm5_Stoichiom.f90
! Time                 : Fri Jan 29 14:37:03 2010
! Working directory    : /gpfs/projects/bsc32/bsc32771/UMO/UMO-Chem/chemistry/KPP/kpp-2.2.1.December2006/models/CBM5
! Equation file        : cbm5.kpp
! Output root filename : cbm5
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



MODULE cbm5_Stoichiom

  USE cbm5_Parameters
  USE cbm5_StoichiomSP

  IMPLICIT NONE

CONTAINS


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! ReactantProd - Reactant Products in each equation
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      ARP       - Reactant product in each equation
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE ReactantProd ( V, F, ARP )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! ARP - Reactant product in each equation
  REAL(kind=dp) :: ARP(NREACT)


! Reactant Products in each equation are useful in the
!     stoichiometric formulation of mass action law
  ARP(1) = V(51)
  ARP(2) = V(45)*F(3)*F(5)
  ARP(3) = V(41)*V(50)
  ARP(4) = V(45)*V(51)
  ARP(5) = V(45)*V(51)
  ARP(6) = V(45)*V(50)
  ARP(7) = V(41)*V(51)
  ARP(8) = V(41)
  ARP(9) = V(41)
  ARP(10) = V(3)*F(5)
  ARP(11) = V(3)*F(1)
  ARP(12) = V(41)*V(48)
  ARP(13) = V(41)*V(43)
  ARP(14) = V(49)
  ARP(15) = V(49)
  ARP(16) = V(49)*V(50)
  ARP(17) = V(49)*V(51)
  ARP(18) = V(49)*V(51)
  ARP(19) = V(8)*F(1)
  ARP(20) = V(8)*F(1)*F(1)
  ARP(21) = V(8)
  ARP(22) = V(50)*V(50)*F(3)
  ARP(23) = V(50)*V(51)*F(1)
  ARP(24) = V(48)*V(50)
  ARP(25) = V(11)
  ARP(26) = V(11)*V(48)
  ARP(27) = V(11)*V(11)
  ARP(28) = V(48)*V(51)
  ARP(29) = V(27)*V(48)
  ARP(30) = V(43)*V(50)
  ARP(31) = V(43)*V(51)
  ARP(32) = V(17)
  ARP(33) = V(17)*V(48)
  ARP(34) = V(43)*V(43)
  ARP(35) = V(43)*V(43)*F(1)
  ARP(36) = V(12)
  ARP(37) = V(12)*V(48)
  ARP(38) = V(3)*F(2)
  ARP(39) = V(48)*F(2)
  ARP(40) = V(45)*V(48)
  ARP(41) = V(48)*V(48)
  ARP(42) = V(48)*V(48)
  ARP(43) = V(43)*V(48)
  ARP(44) = V(43)*V(45)
  ARP(45) = V(12)*V(45)
  ARP(46) = V(45)*V(49)
  ARP(47) = V(48)*V(49)
  ARP(48) = V(43)*V(49)
  ARP(49) = V(41)*V(49)
  ARP(50) = V(49)*V(49)
  ARP(51) = V(17)
  ARP(52) = V(27)
  ARP(53) = V(8)
  ARP(54) = V(42)*V(50)
  ARP(55) = V(36)*V(50)
  ARP(56) = V(42)*V(43)
  ARP(57) = V(36)*V(43)
  ARP(58) = V(42)*V(42)
  ARP(59) = V(36)*V(36)
  ARP(60) = V(36)*V(42)
  ARP(61) = V(40)*V(48)
  ARP(62) = V(40)
  ARP(63) = V(21)*V(48)
  ARP(64) = V(21)
  ARP(65) = V(25)*V(48)
  ARP(66) = V(48)*F(4)
  ARP(67) = V(44)*V(50)
  ARP(68) = V(43)*V(44)
  ARP(69) = V(44)*V(44)
  ARP(70) = V(24)*V(48)
  ARP(71) = V(24)
  ARP(72) = V(7)*V(48)
  ARP(73) = V(39)*V(48)
  ARP(74) = V(39)
  ARP(75) = V(39)
  ARP(76) = V(39)*V(45)
  ARP(77) = V(39)*V(49)
  ARP(78) = V(39)*V(43)
  ARP(79) = V(19)
  ARP(80) = V(19)*V(50)
  ARP(81) = V(19)*V(43)
  ARP(82) = V(13)*V(48)
  ARP(83) = V(38)*V(45)
  ARP(84) = V(38)*V(48)
  ARP(85) = V(38)*V(49)
  ARP(86) = V(38)
  ARP(87) = V(46)*V(50)
  ARP(88) = V(46)*V(51)
  ARP(89) = V(4)
  ARP(90) = V(4)
  ARP(91) = V(43)*V(46)
  ARP(92) = V(44)*V(46)
  ARP(93) = V(42)*V(46)
  ARP(94) = V(46)*V(46)
  ARP(95) = V(14)*V(48)
  ARP(96) = V(14)
  ARP(97) = V(15)*V(48)
  ARP(98) = V(37)*V(45)
  ARP(99) = V(37)*V(48)
  ARP(100) = V(37)*V(49)
  ARP(101) = V(37)
  ARP(102) = V(47)*V(50)
  ARP(103) = V(47)*V(51)
  ARP(104) = V(16)
  ARP(105) = V(16)
  ARP(106) = V(16)*V(48)
  ARP(107) = V(43)*V(47)
  ARP(108) = V(44)*V(47)
  ARP(109) = V(42)*V(47)
  ARP(110) = V(47)*V(47)
  ARP(111) = V(46)*V(47)
  ARP(112) = V(33)*V(48)
  ARP(113) = V(23)
  ARP(114) = V(23)
  ARP(115) = V(23)*V(51)
  ARP(116) = V(30)*V(45)
  ARP(117) = V(30)*V(48)
  ARP(118) = V(30)*V(41)
  ARP(119) = V(30)*V(49)
  ARP(120) = V(28)*V(45)
  ARP(121) = V(28)*V(48)
  ARP(122) = V(28)*V(41)
  ARP(123) = V(28)*V(49)
  ARP(124) = V(29)*V(45)
  ARP(125) = V(29)*V(48)
  ARP(126) = V(29)*V(41)
  ARP(127) = V(29)*V(49)
  ARP(128) = V(5)*V(48)
  ARP(129) = V(18)*V(50)
  ARP(130) = V(18)
  ARP(131) = V(31)*V(48)
  ARP(132) = V(31)*V(49)
  ARP(133) = V(22)*V(51)
  ARP(134) = V(22)*V(43)
  ARP(135) = V(26)
  ARP(136) = V(26)*V(48)
  ARP(137) = V(26)*V(41)
  ARP(138) = V(10)*V(48)
  ARP(139) = V(20)*V(48)
  ARP(140) = V(20)
  ARP(141) = V(34)*V(45)
  ARP(142) = V(34)*V(48)
  ARP(143) = V(34)*V(41)
  ARP(144) = V(34)*V(49)
  ARP(145) = V(35)*V(48)
  ARP(146) = V(35)*V(41)
  ARP(147) = V(35)*V(49)
  ARP(148) = V(35)
  ARP(149) = V(32)*V(45)
  ARP(150) = V(32)*V(48)
  ARP(151) = V(32)*V(41)
  ARP(152) = V(32)*V(49)
  ARP(153) = V(2)*V(48)
  ARP(154) = V(9)*V(48)
  ARP(155) = V(6)*V(48)
  ARP(156) = V(34)*V(51)
      
END SUBROUTINE ReactantProd

! End of ReactantProd function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
! 
! JacReactantProd - Jacobian of Reactant Products vector
!   Arguments :
!      V         - Concentrations of variable species (local)
!      F         - Concentrations of fixed species (local)
!      JVRP      - d ARP(1:NREACT)/d VAR (1:NVAR)
! 
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SUBROUTINE JacReactantProd ( V, F, JVRP )

! V - Concentrations of variable species (local)
  REAL(kind=dp) :: V(NVAR)
! F - Concentrations of fixed species (local)
  REAL(kind=dp) :: F(NFIX)
! JVRP - d ARP(1:NREACT)/d VAR (1:NVAR)
  REAL(kind=dp) :: JVRP(NJVRP)


! Reactant Products in each equation are useful in the
!    stoichiometric formulation of mass action law
! Below we compute the Jacobian of the Reactant Products vector
!    w.r.t. variable species: d ARP(1:NREACT) / d Var(1:NVAR)

! JVRP(1) = dARP(1)/dV(51)
  JVRP(1) = 1
! JVRP(2) = dARP(2)/dV(45)
  JVRP(2) = F(3)*F(5)
! JVRP(3) = dARP(3)/dV(41)
  JVRP(3) = V(50)
! JVRP(4) = dARP(3)/dV(50)
  JVRP(4) = V(41)
! JVRP(5) = dARP(4)/dV(45)
  JVRP(5) = V(51)
! JVRP(6) = dARP(4)/dV(51)
  JVRP(6) = V(45)
! JVRP(7) = dARP(5)/dV(45)
  JVRP(7) = V(51)
! JVRP(8) = dARP(5)/dV(51)
  JVRP(8) = V(45)
! JVRP(9) = dARP(6)/dV(45)
  JVRP(9) = V(50)
! JVRP(10) = dARP(6)/dV(50)
  JVRP(10) = V(45)
! JVRP(11) = dARP(7)/dV(41)
  JVRP(11) = V(51)
! JVRP(12) = dARP(7)/dV(51)
  JVRP(12) = V(41)
! JVRP(13) = dARP(8)/dV(41)
  JVRP(13) = 1
! JVRP(14) = dARP(9)/dV(41)
  JVRP(14) = 1
! JVRP(15) = dARP(10)/dV(3)
  JVRP(15) = F(5)
! JVRP(16) = dARP(11)/dV(3)
  JVRP(16) = F(1)
! JVRP(17) = dARP(12)/dV(41)
  JVRP(17) = V(48)
! JVRP(18) = dARP(12)/dV(48)
  JVRP(18) = V(41)
! JVRP(19) = dARP(13)/dV(41)
  JVRP(19) = V(43)
! JVRP(20) = dARP(13)/dV(43)
  JVRP(20) = V(41)
! JVRP(21) = dARP(14)/dV(49)
  JVRP(21) = 1
! JVRP(22) = dARP(15)/dV(49)
  JVRP(22) = 1
! JVRP(23) = dARP(16)/dV(49)
  JVRP(23) = V(50)
! JVRP(24) = dARP(16)/dV(50)
  JVRP(24) = V(49)
! JVRP(25) = dARP(17)/dV(49)
  JVRP(25) = V(51)
! JVRP(26) = dARP(17)/dV(51)
  JVRP(26) = V(49)
! JVRP(27) = dARP(18)/dV(49)
  JVRP(27) = V(51)
! JVRP(28) = dARP(18)/dV(51)
  JVRP(28) = V(49)
! JVRP(29) = dARP(19)/dV(8)
  JVRP(29) = F(1)
! JVRP(30) = dARP(20)/dV(8)
  JVRP(30) = F(1)*F(1)
! JVRP(31) = dARP(21)/dV(8)
  JVRP(31) = 1
! JVRP(32) = dARP(22)/dV(50)
  JVRP(32) = 2*V(50)*F(3)
! JVRP(33) = dARP(23)/dV(50)
  JVRP(33) = V(51)*F(1)
! JVRP(34) = dARP(23)/dV(51)
  JVRP(34) = V(50)*F(1)
! JVRP(35) = dARP(24)/dV(48)
  JVRP(35) = V(50)
! JVRP(36) = dARP(24)/dV(50)
  JVRP(36) = V(48)
! JVRP(37) = dARP(25)/dV(11)
  JVRP(37) = 1
! JVRP(38) = dARP(26)/dV(11)
  JVRP(38) = V(48)
! JVRP(39) = dARP(26)/dV(48)
  JVRP(39) = V(11)
! JVRP(40) = dARP(27)/dV(11)
  JVRP(40) = 2*V(11)
! JVRP(41) = dARP(28)/dV(48)
  JVRP(41) = V(51)
! JVRP(42) = dARP(28)/dV(51)
  JVRP(42) = V(48)
! JVRP(43) = dARP(29)/dV(27)
  JVRP(43) = V(48)
! JVRP(44) = dARP(29)/dV(48)
  JVRP(44) = V(27)
! JVRP(45) = dARP(30)/dV(43)
  JVRP(45) = V(50)
! JVRP(46) = dARP(30)/dV(50)
  JVRP(46) = V(43)
! JVRP(47) = dARP(31)/dV(43)
  JVRP(47) = V(51)
! JVRP(48) = dARP(31)/dV(51)
  JVRP(48) = V(43)
! JVRP(49) = dARP(32)/dV(17)
  JVRP(49) = 1
! JVRP(50) = dARP(33)/dV(17)
  JVRP(50) = V(48)
! JVRP(51) = dARP(33)/dV(48)
  JVRP(51) = V(17)
! JVRP(52) = dARP(34)/dV(43)
  JVRP(52) = 2*V(43)
! JVRP(53) = dARP(35)/dV(43)
  JVRP(53) = 2*V(43)*F(1)
! JVRP(54) = dARP(36)/dV(12)
  JVRP(54) = 1
! JVRP(55) = dARP(37)/dV(12)
  JVRP(55) = V(48)
! JVRP(56) = dARP(37)/dV(48)
  JVRP(56) = V(12)
! JVRP(57) = dARP(38)/dV(3)
  JVRP(57) = F(2)
! JVRP(58) = dARP(39)/dV(48)
  JVRP(58) = F(2)
! JVRP(59) = dARP(40)/dV(45)
  JVRP(59) = V(48)
! JVRP(60) = dARP(40)/dV(48)
  JVRP(60) = V(45)
! JVRP(61) = dARP(41)/dV(48)
  JVRP(61) = 2*V(48)
! JVRP(62) = dARP(42)/dV(48)
  JVRP(62) = 2*V(48)
! JVRP(63) = dARP(43)/dV(43)
  JVRP(63) = V(48)
! JVRP(64) = dARP(43)/dV(48)
  JVRP(64) = V(43)
! JVRP(65) = dARP(44)/dV(43)
  JVRP(65) = V(45)
! JVRP(66) = dARP(44)/dV(45)
  JVRP(66) = V(43)
! JVRP(67) = dARP(45)/dV(12)
  JVRP(67) = V(45)
! JVRP(68) = dARP(45)/dV(45)
  JVRP(68) = V(12)
! JVRP(69) = dARP(46)/dV(45)
  JVRP(69) = V(49)
! JVRP(70) = dARP(46)/dV(49)
  JVRP(70) = V(45)
! JVRP(71) = dARP(47)/dV(48)
  JVRP(71) = V(49)
! JVRP(72) = dARP(47)/dV(49)
  JVRP(72) = V(48)
! JVRP(73) = dARP(48)/dV(43)
  JVRP(73) = V(49)
! JVRP(74) = dARP(48)/dV(49)
  JVRP(74) = V(43)
! JVRP(75) = dARP(49)/dV(41)
  JVRP(75) = V(49)
! JVRP(76) = dARP(49)/dV(49)
  JVRP(76) = V(41)
! JVRP(77) = dARP(50)/dV(49)
  JVRP(77) = 2*V(49)
! JVRP(78) = dARP(51)/dV(17)
  JVRP(78) = 1
! JVRP(79) = dARP(52)/dV(27)
  JVRP(79) = 1
! JVRP(80) = dARP(53)/dV(8)
  JVRP(80) = 1
! JVRP(81) = dARP(54)/dV(42)
  JVRP(81) = V(50)
! JVRP(82) = dARP(54)/dV(50)
  JVRP(82) = V(42)
! JVRP(83) = dARP(55)/dV(36)
  JVRP(83) = V(50)
! JVRP(84) = dARP(55)/dV(50)
  JVRP(84) = V(36)
! JVRP(85) = dARP(56)/dV(42)
  JVRP(85) = V(43)
! JVRP(86) = dARP(56)/dV(43)
  JVRP(86) = V(42)
! JVRP(87) = dARP(57)/dV(36)
  JVRP(87) = V(43)
! JVRP(88) = dARP(57)/dV(43)
  JVRP(88) = V(36)
! JVRP(89) = dARP(58)/dV(42)
  JVRP(89) = 2*V(42)
! JVRP(90) = dARP(59)/dV(36)
  JVRP(90) = 2*V(36)
! JVRP(91) = dARP(60)/dV(36)
  JVRP(91) = V(42)
! JVRP(92) = dARP(60)/dV(42)
  JVRP(92) = V(36)
! JVRP(93) = dARP(61)/dV(40)
  JVRP(93) = V(48)
! JVRP(94) = dARP(61)/dV(48)
  JVRP(94) = V(40)
! JVRP(95) = dARP(62)/dV(40)
  JVRP(95) = 1
! JVRP(96) = dARP(63)/dV(21)
  JVRP(96) = V(48)
! JVRP(97) = dARP(63)/dV(48)
  JVRP(97) = V(21)
! JVRP(98) = dARP(64)/dV(21)
  JVRP(98) = 1
! JVRP(99) = dARP(65)/dV(25)
  JVRP(99) = V(48)
! JVRP(100) = dARP(65)/dV(48)
  JVRP(100) = V(25)
! JVRP(101) = dARP(66)/dV(48)
  JVRP(101) = F(4)
! JVRP(102) = dARP(67)/dV(44)
  JVRP(102) = V(50)
! JVRP(103) = dARP(67)/dV(50)
  JVRP(103) = V(44)
! JVRP(104) = dARP(68)/dV(43)
  JVRP(104) = V(44)
! JVRP(105) = dARP(68)/dV(44)
  JVRP(105) = V(43)
! JVRP(106) = dARP(69)/dV(44)
  JVRP(106) = 2*V(44)
! JVRP(107) = dARP(70)/dV(24)
  JVRP(107) = V(48)
! JVRP(108) = dARP(70)/dV(48)
  JVRP(108) = V(24)
! JVRP(109) = dARP(71)/dV(24)
  JVRP(109) = 1
! JVRP(110) = dARP(72)/dV(7)
  JVRP(110) = V(48)
! JVRP(111) = dARP(72)/dV(48)
  JVRP(111) = V(7)
! JVRP(112) = dARP(73)/dV(39)
  JVRP(112) = V(48)
! JVRP(113) = dARP(73)/dV(48)
  JVRP(113) = V(39)
! JVRP(114) = dARP(74)/dV(39)
  JVRP(114) = 1
! JVRP(115) = dARP(75)/dV(39)
  JVRP(115) = 1
! JVRP(116) = dARP(76)/dV(39)
  JVRP(116) = V(45)
! JVRP(117) = dARP(76)/dV(45)
  JVRP(117) = V(39)
! JVRP(118) = dARP(77)/dV(39)
  JVRP(118) = V(49)
! JVRP(119) = dARP(77)/dV(49)
  JVRP(119) = V(39)
! JVRP(120) = dARP(78)/dV(39)
  JVRP(120) = V(43)
! JVRP(121) = dARP(78)/dV(43)
  JVRP(121) = V(39)
! JVRP(122) = dARP(79)/dV(19)
  JVRP(122) = 1
! JVRP(123) = dARP(80)/dV(19)
  JVRP(123) = V(50)
! JVRP(124) = dARP(80)/dV(50)
  JVRP(124) = V(19)
! JVRP(125) = dARP(81)/dV(19)
  JVRP(125) = V(43)
! JVRP(126) = dARP(81)/dV(43)
  JVRP(126) = V(19)
! JVRP(127) = dARP(82)/dV(13)
  JVRP(127) = V(48)
! JVRP(128) = dARP(82)/dV(48)
  JVRP(128) = V(13)
! JVRP(129) = dARP(83)/dV(38)
  JVRP(129) = V(45)
! JVRP(130) = dARP(83)/dV(45)
  JVRP(130) = V(38)
! JVRP(131) = dARP(84)/dV(38)
  JVRP(131) = V(48)
! JVRP(132) = dARP(84)/dV(48)
  JVRP(132) = V(38)
! JVRP(133) = dARP(85)/dV(38)
  JVRP(133) = V(49)
! JVRP(134) = dARP(85)/dV(49)
  JVRP(134) = V(38)
! JVRP(135) = dARP(86)/dV(38)
  JVRP(135) = 1
! JVRP(136) = dARP(87)/dV(46)
  JVRP(136) = V(50)
! JVRP(137) = dARP(87)/dV(50)
  JVRP(137) = V(46)
! JVRP(138) = dARP(88)/dV(46)
  JVRP(138) = V(51)
! JVRP(139) = dARP(88)/dV(51)
  JVRP(139) = V(46)
! JVRP(140) = dARP(89)/dV(4)
  JVRP(140) = 1
! JVRP(141) = dARP(90)/dV(4)
  JVRP(141) = 1
! JVRP(142) = dARP(91)/dV(43)
  JVRP(142) = V(46)
! JVRP(143) = dARP(91)/dV(46)
  JVRP(143) = V(43)
! JVRP(144) = dARP(92)/dV(44)
  JVRP(144) = V(46)
! JVRP(145) = dARP(92)/dV(46)
  JVRP(145) = V(44)
! JVRP(146) = dARP(93)/dV(42)
  JVRP(146) = V(46)
! JVRP(147) = dARP(93)/dV(46)
  JVRP(147) = V(42)
! JVRP(148) = dARP(94)/dV(46)
  JVRP(148) = 2*V(46)
! JVRP(149) = dARP(95)/dV(14)
  JVRP(149) = V(48)
! JVRP(150) = dARP(95)/dV(48)
  JVRP(150) = V(14)
! JVRP(151) = dARP(96)/dV(14)
  JVRP(151) = 1
! JVRP(152) = dARP(97)/dV(15)
  JVRP(152) = V(48)
! JVRP(153) = dARP(97)/dV(48)
  JVRP(153) = V(15)
! JVRP(154) = dARP(98)/dV(37)
  JVRP(154) = V(45)
! JVRP(155) = dARP(98)/dV(45)
  JVRP(155) = V(37)
! JVRP(156) = dARP(99)/dV(37)
  JVRP(156) = V(48)
! JVRP(157) = dARP(99)/dV(48)
  JVRP(157) = V(37)
! JVRP(158) = dARP(100)/dV(37)
  JVRP(158) = V(49)
! JVRP(159) = dARP(100)/dV(49)
  JVRP(159) = V(37)
! JVRP(160) = dARP(101)/dV(37)
  JVRP(160) = 1
! JVRP(161) = dARP(102)/dV(47)
  JVRP(161) = V(50)
! JVRP(162) = dARP(102)/dV(50)
  JVRP(162) = V(47)
! JVRP(163) = dARP(103)/dV(47)
  JVRP(163) = V(51)
! JVRP(164) = dARP(103)/dV(51)
  JVRP(164) = V(47)
! JVRP(165) = dARP(104)/dV(16)
  JVRP(165) = 1
! JVRP(166) = dARP(105)/dV(16)
  JVRP(166) = 1
! JVRP(167) = dARP(106)/dV(16)
  JVRP(167) = V(48)
! JVRP(168) = dARP(106)/dV(48)
  JVRP(168) = V(16)
! JVRP(169) = dARP(107)/dV(43)
  JVRP(169) = V(47)
! JVRP(170) = dARP(107)/dV(47)
  JVRP(170) = V(43)
! JVRP(171) = dARP(108)/dV(44)
  JVRP(171) = V(47)
! JVRP(172) = dARP(108)/dV(47)
  JVRP(172) = V(44)
! JVRP(173) = dARP(109)/dV(42)
  JVRP(173) = V(47)
! JVRP(174) = dARP(109)/dV(47)
  JVRP(174) = V(42)
! JVRP(175) = dARP(110)/dV(47)
  JVRP(175) = 2*V(47)
! JVRP(176) = dARP(111)/dV(46)
  JVRP(176) = V(47)
! JVRP(177) = dARP(111)/dV(47)
  JVRP(177) = V(46)
! JVRP(178) = dARP(112)/dV(33)
  JVRP(178) = V(48)
! JVRP(179) = dARP(112)/dV(48)
  JVRP(179) = V(33)
! JVRP(180) = dARP(113)/dV(23)
  JVRP(180) = 1
! JVRP(181) = dARP(114)/dV(23)
  JVRP(181) = 1
! JVRP(182) = dARP(115)/dV(23)
  JVRP(182) = V(51)
! JVRP(183) = dARP(115)/dV(51)
  JVRP(183) = V(23)
! JVRP(184) = dARP(116)/dV(30)
  JVRP(184) = V(45)
! JVRP(185) = dARP(116)/dV(45)
  JVRP(185) = V(30)
! JVRP(186) = dARP(117)/dV(30)
  JVRP(186) = V(48)
! JVRP(187) = dARP(117)/dV(48)
  JVRP(187) = V(30)
! JVRP(188) = dARP(118)/dV(30)
  JVRP(188) = V(41)
! JVRP(189) = dARP(118)/dV(41)
  JVRP(189) = V(30)
! JVRP(190) = dARP(119)/dV(30)
  JVRP(190) = V(49)
! JVRP(191) = dARP(119)/dV(49)
  JVRP(191) = V(30)
! JVRP(192) = dARP(120)/dV(28)
  JVRP(192) = V(45)
! JVRP(193) = dARP(120)/dV(45)
  JVRP(193) = V(28)
! JVRP(194) = dARP(121)/dV(28)
  JVRP(194) = V(48)
! JVRP(195) = dARP(121)/dV(48)
  JVRP(195) = V(28)
! JVRP(196) = dARP(122)/dV(28)
  JVRP(196) = V(41)
! JVRP(197) = dARP(122)/dV(41)
  JVRP(197) = V(28)
! JVRP(198) = dARP(123)/dV(28)
  JVRP(198) = V(49)
! JVRP(199) = dARP(123)/dV(49)
  JVRP(199) = V(28)
! JVRP(200) = dARP(124)/dV(29)
  JVRP(200) = V(45)
! JVRP(201) = dARP(124)/dV(45)
  JVRP(201) = V(29)
! JVRP(202) = dARP(125)/dV(29)
  JVRP(202) = V(48)
! JVRP(203) = dARP(125)/dV(48)
  JVRP(203) = V(29)
! JVRP(204) = dARP(126)/dV(29)
  JVRP(204) = V(41)
! JVRP(205) = dARP(126)/dV(41)
  JVRP(205) = V(29)
! JVRP(206) = dARP(127)/dV(29)
  JVRP(206) = V(49)
! JVRP(207) = dARP(127)/dV(49)
  JVRP(207) = V(29)
! JVRP(208) = dARP(128)/dV(5)
  JVRP(208) = V(48)
! JVRP(209) = dARP(128)/dV(48)
  JVRP(209) = V(5)
! JVRP(210) = dARP(129)/dV(18)
  JVRP(210) = V(50)
! JVRP(211) = dARP(129)/dV(50)
  JVRP(211) = V(18)
! JVRP(212) = dARP(130)/dV(18)
  JVRP(212) = 1
! JVRP(213) = dARP(131)/dV(31)
  JVRP(213) = V(48)
! JVRP(214) = dARP(131)/dV(48)
  JVRP(214) = V(31)
! JVRP(215) = dARP(132)/dV(31)
  JVRP(215) = V(49)
! JVRP(216) = dARP(132)/dV(49)
  JVRP(216) = V(31)
! JVRP(217) = dARP(133)/dV(22)
  JVRP(217) = V(51)
! JVRP(218) = dARP(133)/dV(51)
  JVRP(218) = V(22)
! JVRP(219) = dARP(134)/dV(22)
  JVRP(219) = V(43)
! JVRP(220) = dARP(134)/dV(43)
  JVRP(220) = V(22)
! JVRP(221) = dARP(135)/dV(26)
  JVRP(221) = 1
! JVRP(222) = dARP(136)/dV(26)
  JVRP(222) = V(48)
! JVRP(223) = dARP(136)/dV(48)
  JVRP(223) = V(26)
! JVRP(224) = dARP(137)/dV(26)
  JVRP(224) = V(41)
! JVRP(225) = dARP(137)/dV(41)
  JVRP(225) = V(26)
! JVRP(226) = dARP(138)/dV(10)
  JVRP(226) = V(48)
! JVRP(227) = dARP(138)/dV(48)
  JVRP(227) = V(10)
! JVRP(228) = dARP(139)/dV(20)
  JVRP(228) = V(48)
! JVRP(229) = dARP(139)/dV(48)
  JVRP(229) = V(20)
! JVRP(230) = dARP(140)/dV(20)
  JVRP(230) = 1
! JVRP(231) = dARP(141)/dV(34)
  JVRP(231) = V(45)
! JVRP(232) = dARP(141)/dV(45)
  JVRP(232) = V(34)
! JVRP(233) = dARP(142)/dV(34)
  JVRP(233) = V(48)
! JVRP(234) = dARP(142)/dV(48)
  JVRP(234) = V(34)
! JVRP(235) = dARP(143)/dV(34)
  JVRP(235) = V(41)
! JVRP(236) = dARP(143)/dV(41)
  JVRP(236) = V(34)
! JVRP(237) = dARP(144)/dV(34)
  JVRP(237) = V(49)
! JVRP(238) = dARP(144)/dV(49)
  JVRP(238) = V(34)
! JVRP(239) = dARP(145)/dV(35)
  JVRP(239) = V(48)
! JVRP(240) = dARP(145)/dV(48)
  JVRP(240) = V(35)
! JVRP(241) = dARP(146)/dV(35)
  JVRP(241) = V(41)
! JVRP(242) = dARP(146)/dV(41)
  JVRP(242) = V(35)
! JVRP(243) = dARP(147)/dV(35)
  JVRP(243) = V(49)
! JVRP(244) = dARP(147)/dV(49)
  JVRP(244) = V(35)
! JVRP(245) = dARP(148)/dV(35)
  JVRP(245) = 1
! JVRP(246) = dARP(149)/dV(32)
  JVRP(246) = V(45)
! JVRP(247) = dARP(149)/dV(45)
  JVRP(247) = V(32)
! JVRP(248) = dARP(150)/dV(32)
  JVRP(248) = V(48)
! JVRP(249) = dARP(150)/dV(48)
  JVRP(249) = V(32)
! JVRP(250) = dARP(151)/dV(32)
  JVRP(250) = V(41)
! JVRP(251) = dARP(151)/dV(41)
  JVRP(251) = V(32)
! JVRP(252) = dARP(152)/dV(32)
  JVRP(252) = V(49)
! JVRP(253) = dARP(152)/dV(49)
  JVRP(253) = V(32)
! JVRP(254) = dARP(153)/dV(2)
  JVRP(254) = V(48)
! JVRP(255) = dARP(153)/dV(48)
  JVRP(255) = V(2)
! JVRP(256) = dARP(154)/dV(9)
  JVRP(256) = V(48)
! JVRP(257) = dARP(154)/dV(48)
  JVRP(257) = V(9)
! JVRP(258) = dARP(155)/dV(6)
  JVRP(258) = V(48)
! JVRP(259) = dARP(155)/dV(48)
  JVRP(259) = V(6)
! JVRP(260) = dARP(156)/dV(34)
  JVRP(260) = V(51)
! JVRP(261) = dARP(156)/dV(51)
  JVRP(261) = V(34)
      
END SUBROUTINE JacReactantProd

! End of JacReactantProd function
! ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



! Begin Derivative w.r.t. Rate Coefficients

! ------------------------------------------------------------------------------
! Subroutine for the derivative of Fun with respect to rate coefficients
! -----------------------------------------------------------------------------

      SUBROUTINE  dFun_dRcoeff( V, F, NCOEFF, JCOEFF, DFDR )
       
      USE cbm5_Parameters
      USE cbm5_StoichiomSP
      IMPLICIT NONE 

! V - Concentrations of variable/radical/fixed species            
      REAL(kind=dp) V(NVAR), F(NFIX)
! NCOEFF - the number of rate coefficients with respect to which we differentiate
      INTEGER NCOEFF       
! JCOEFF - a vector of integers containing the indices of reactions (rate
!          coefficients) with respect to which we differentiate
      INTEGER JCOEFF(NCOEFF)       
! DFDR  - a matrix containg derivative values; specifically, 
!         column j contains d Fun(1:NVAR) / d RCT( JCOEFF(j) )
!         for each 1 <= j <= NCOEFF
!         This matrix is stored in a column-wise linearized format
      REAL(kind=dp) DFDR(NVAR*NCOEFF)

! Local vector with reactant products
      REAL(kind=dp) A_RPROD(NREACT)
      REAL(kind=dp) aj
      INTEGER i,j,k
      
! Compute the reactant products of all reactions     
      CALL ReactantProd ( V, F, A_RPROD )

! Compute the derivatives by multiplying column JCOEFF(j) of the stoichiometric matrix with A_RPROD       
      DO j=1,NCOEFF
!                  Initialize the j-th column of derivative matrix to zero       
         DO i=1,NVAR
           DFDR(i+NVAR*(j-1)) = 0.0_dp 
         END DO
!                  Column JCOEFF(j) in the stoichiometric matrix times the
!                  reactant product  of the JCOEFF(j)-th reaction      
!                  give the j-th column of the derivative matrix   
         aj = A_RPROD(JCOEFF(j))
         DO k=CCOL_STOICM(JCOEFF(j)),CCOL_STOICM(JCOEFF(j)+1)-1
           DFDR(IROW_STOICM(k)+NVAR*(j-1)) = STOICM(k)*aj
         END DO
      END DO
      
      END SUBROUTINE  dFun_dRcoeff

! End Derivative w.r.t. Rate Coefficients


! Begin Jacobian Derivative w.r.t. Rate Coefficients

! ------------------------------------------------------------------------------
! Subroutine for the derivative of Jac with respect to rate coefficients
! Times a user vector
! -----------------------------------------------------------------------------

      SUBROUTINE  dJac_dRcoeff( V, F, U, NCOEFF, JCOEFF, DJDR )
       
      USE cbm5_Parameters
      USE cbm5_StoichiomSP
      IMPLICIT NONE 

! V - Concentrations of variable/fixed species            
      REAL(kind=dp) V(NVAR), F(NFIX)
! U - User-supplied Vector           
      REAL(kind=dp) U(NVAR)
! NCOEFF - the number of rate coefficients with respect to which we differentiate
      INTEGER NCOEFF       
! JCOEFF - a vector of integers containing the indices of reactions (rate
!          coefficients) with respect to which we differentiate
      INTEGER JCOEFF(NCOEFF)       
! DFDR  - a matrix containg derivative values; specifically, 
!         column j contains d Jac(1:NVAR) / d RCT( JCOEFF(j) ) * U
!                     for each 1 <= j <= NCOEFF
!         This matrix is stored in a column-wise linearized format
      REAL(kind=dp) DJDR(NVAR*NCOEFF)

! Local vector for Jacobian of reactant products
      REAL(kind=dp) JV_RPROD(NJVRP)
      REAL(kind=dp) aj
      INTEGER i,j,k
      
! Compute the Jacobian of all reactant products   
      CALL JacReactantProd( V, F, JV_RPROD )

! Compute the derivatives by multiplying column JCOEFF(j) of the stoichiometric matrix with A_PROD       
      DO j=1,NCOEFF
!                  Initialize the j-th column of derivative matrix to zero       
         DO i=1,NVAR
           DJDR(i+NVAR*(j-1)) = 0.0_dp
         END DO
!                  Column JCOEFF(j) in the stoichiometric matrix times the
!                  ( Gradient of reactant product of the JCOEFF(j)-th reaction X user vector )    
!                  give the j-th column of the derivative matrix   
!
!          Row JCOEFF(j) of JV_RPROD times the user vector
         aj = 0.0_dp
         DO k=CROW_JVRP(JCOEFF(j)),CROW_JVRP(JCOEFF(j)+1)-1
             aj = aj + JV_RPROD(k)*U(ICOL_JVRP(k))
         END DO
!          Column JCOEFF(j) of Stoichiom. matrix times aj         
         DO k=CCOL_STOICM(JCOEFF(j)),CCOL_STOICM(JCOEFF(j)+1)-1
           DJDR(IROW_STOICM(k)+NVAR*(j-1)) = STOICM(k)*aj
         END DO
      END DO
      
      END SUBROUTINE  dJac_dRcoeff

! End Jacobian Derivative w.r.t. Rate Coefficients


END MODULE cbm5_Stoichiom

