	MODULE RXCM
!Models-3/CMAQ code adapted for MONARCH

!***********************************************************************
!   Portions of Models-3/CMAQ software were developed or based on      *
!   information from various groups: Federal Government employees,     *
!   contractors working on a United States Government contract, and    *
!   non-Federal sources (including research institutions).  These      *
!   research institutions have given the Government permission to      *
!   use, prepare derivative works, and distribute copies of their      *
!   work in Models-3/CMAQ to the public and to permit others to do     *
!   so.  EPA therefore grants similar permissions for use of the       *
!   Models-3/CMAQ software, but users are requested to provide copies  *
!   of derivative works to the Government without restrictions as to   *
!   use by others.  Users are responsible for acquiring their own      *
!   copies of commercial software associated with Models-3/CMAQ and    *
!   for complying with vendor requirements.  Software copyrights by    *
!   the MCNC Environmental Modeling Center are used with their         *
!   permissions subject to the above restrictions.                     *
!***********************************************************************

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /project/air5/sjr/CMAS4.7/rel/models/include/ICL/src/mech/cb05cl_ae4_aq/RXCM.EXT,v 1.1.1.1 2008/09/19 18:12:05 sjr Exp $ 

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! -------- Mechanism Reactions, Rates, etc. COMMON INCLUDE File --------
!  /home/hutzellb/cmaq_toxics/sept08_release/mech_updates/cb05cl_ae4
!  /RXCM.EXT
! for Mechanism Name: CB05CL_AE4_AQ   

! The following are reserved symbols declared in this INCLUDE file:
!    MECHNAME  = Mechanism name
!    NRXNS     = Number of mechanism reactions
!    KUNITS    = Units of mechanism reactions
!    KTYPE     = Reaction type
!    IRXBITS   = Bit test mask vector for selected reactions
!    IORDER    = Order of the reaction
!    KTN1      = Number of type 1 reactions
!    KRX1      = Reactions list pointer to type 1 reactions
!    KTN2      = Number of type 2 reactions
!    KRX2      = Reactions list pointer to type 2 reactions
!    KTN3      = Number of type 3 reactions
!    KRX3      = Reactions list pointer to type 3 reactions
!    KTN4      = Number of type 4 reactions
!    KRX4      = Reactions list pointer to type 4 reactions
!    KTN5      = Number of type 5 reactions
!    KRX5      = Reactions list pointer to type 5 reactions
!    KTN6      = Number of type 6 reactions
!    KRX6      = Reactions list pointer to type 6 reactions
!    KTN7      = Number of type 7 reactions
!    KRX7      = Reactions list pointer to type 7 reactions

!    NWM       = Number of air 3-body reactions
!    NRXWM     = Reactions list pointer to air 3-body reactions
!    ATM_AIR   = air 3-body reactions concentration
!    NWW       = Number of H2O 3-body reactions
!    NRXWW     = Reactions list pointer to H2O 3-body reactions
!    NWO2      = Number of reactions with O2
!    NRXWO2    = Reactions list pointer to O2 reactions
!    ATM_O2    = Oxygen reactions concentration
!    NWN2      = Number of N2 3-body reactions
!    NRXWN2    = Reactions list pointer to N2 3-body reactions
!    ATM_N2    = Nitrogen 3-body reactions concentration
!    NWCH4     = Number of reactions with CH4
!    NRXWCH4   = Reactions list pointer to CH4 reactions
!    ATM_CH4   = Methane reactions concentration
!    NWH2      = Number of reactions with H2
!    NRXWH2    = Reactions list pointer to H2 reactions
!    ATM_H2    = Hydrogen reactions concentration

!    MXPRD     = Maximum number of mechanism reaction products
!    IRR       = Reactions list pointer to reactants and products
!    RTDAT     = Kinetic reaction rates expressions components
!    NFALLOFFF = Number of falloff reactions
!    IRRFALL   = Reactions list pointer to falloff reactions
!    RFDAT     = Falloff reaction rates expressions components
!    SC        = Stoichiometric coefficients
!    NREACT    = Number of reactants in each mechanism reaction
!    NPRDCT    = Number of products in each mechanism reaction
!    RXLABEL   = Character label list for mechanism reactions
!    NMPHOT    = Number of mechanism photolytic reactions
!    NPHOTAB   = Number of photolytic reactions tables
!    IPH       = Reactions list pointer to photolytic reactions and tables

      CHARACTER( 32 ), PARAMETER :: MECHNAME = 'CB05CL_AE4_AQ   '

!MONARCH      INTEGER, PARAMETER :: NRXNS = 177
      INTEGER, PARAMETER :: NRXNS = 180
!MONARCH

      INTEGER            :: KUNITS

      INTEGER            :: KTYPE( NRXNS )

      INTEGER            :: IRXBITS( NRXNS )

      INTEGER            :: IORDER( NRXNS )

!MONARCH      INTEGER, PARAMETER :: KTN1 =  48
      INTEGER, PARAMETER :: KTN1 =  50 !48
!MONARCH
      INTEGER            :: KRX1( KTN1 )

      INTEGER, PARAMETER :: KTN2 =   1
      INTEGER            :: KRX2( KTN2 )

      INTEGER, PARAMETER :: KTN3 =  82
      INTEGER            :: KRX3( KTN3 )

      INTEGER, PARAMETER :: KTN4 =   1
      INTEGER            :: KRX4( KTN4 )

      INTEGER, PARAMETER :: KTN5 =   0
      INTEGER            :: KRX5( 1 )

      INTEGER, PARAMETER :: KTN6 =   0
      INTEGER            :: KRX6( 1 )

      INTEGER, PARAMETER :: KTN7 =   0
      INTEGER            :: KRX7( 1 )

!MONARCH      INTEGER, PARAMETER :: NWM =   2
      INTEGER, PARAMETER :: NWM =   3 !2
!MONARCH
      INTEGER            :: NRXWM( NWM )
      REAL,    PARAMETER :: ATM_AIR = 1.00000E+06

!MONARCH      INTEGER, PARAMETER :: NWW =   6
      INTEGER, PARAMETER :: NWW =   7 !6
!MONARCH
      INTEGER            :: NRXWW( NWW )

      INTEGER, PARAMETER :: NWO2 =   2
      INTEGER            :: NRXWO2( NWO2 )
      REAL,    PARAMETER :: ATM_O2 = 2.09500E+05

      INTEGER, PARAMETER :: NWN2 =   0
      INTEGER            :: NRXWN2( 1 )
      REAL,    PARAMETER :: ATM_N2 = 7.80800E+05

      INTEGER, PARAMETER :: NWCH4 =   2
      INTEGER            :: NRXWCH4( NWCH4 )
      REAL,    PARAMETER :: ATM_CH4 = 1.786e+00 !1.85000E+00

      INTEGER, PARAMETER :: NWH2 =   2

      INTEGER            :: NRXWH2( NWH2 )
      REAL,    PARAMETER :: ATM_H2 = 5.60000E-01

      INTEGER, PARAMETER :: MXPRD =  10
      INTEGER            :: IRR( NRXNS,MXPRD+3 )

      INTEGER, PARAMETER :: NFALLOFF =  19
      INTEGER            :: IRRFALL( NFALLOFF )

      REAL               :: SC( NRXNS,MXPRD )

      INTEGER            :: NREACT( NRXNS )
      INTEGER            :: NPRDCT( NRXNS )

!MONARCH      INTEGER, PARAMETER :: NMPHOT =  26
      INTEGER, PARAMETER :: NMPHOT =  27 !26
!MONARCH
      INTEGER            :: IPH( NMPHOT,3 )

      COMMON     / MECHRX1 /
     &             KUNITS,
     &             KTYPE,
     &             IRXBITS,
     &             IORDER,
     &             KRX1,
     &             KRX2,
     &             KRX3,
     &             KRX4,
     &             KRX7,
     &             KRX5,
     &             KRX6,
     &             NRXWM,
     &             NRXWW,
     &             NRXWO2,
     &             NRXWN2,
     &             NRXWCH4,
     &             NRXWH2,
     &             IRR,
     &             IRRFALL,
     &             SC,
     &             NREACT,
     &             NPRDCT,
     &             IPH

      REAL( 8 )          :: RTDAT( 3,NRXNS )
      REAL( 8 )          :: RFDAT( 5,NFALLOFF )

      COMMON     / MECHRX2 /
     &             RTDAT,
     &             RFDAT

!MONARCH      INTEGER, PARAMETER :: NPHOTAB =  23
      INTEGER, PARAMETER :: NPHOTAB =  24
!MONARCH
      CHARACTER( 16 )    :: PHOTAB( NPHOTAB )

      CHARACTER( 16 )    :: RXLABEL( NRXNS )

      COMMON     / MECHRX3 /
     &             PHOTAB,
     &             RXLABEL

! End of Mechanism Reactions, Rates, etc. COMMON INCLUDE File ----------



! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /project/air5/sjr/CMAS4.7/rel/models/include/ICL/src/mech/cb05cl_ae4_aq/RXDT.EXT,v 1.1.1.1 2008/09/19 18:12:05 sjr Exp $ 

! what(1) key, module and SID; SCCS file; date and time of last delta:
! %W% %P% %G% %U%

! --------- Mechanism Reactions, Rates, etc. DATA INCLUDE File ---------
!  /home/hutzellb/cmaq_toxics/sept08_release/mech_updates/cb05cl_ae4
!  /RXDT.EXT
! Generated from ...
!  /home/hutzellb/cmaq_toxics/sept08_release/mech_updates/cb05cl_ae4
!  /mech.def
! for Mechanism Name: CB05CL_AE4_AQ   

! This DATA INCLUDE file must be preceded by the corresponding
! COMMON INCLUDE file, which contains all the appropriate type
! declarations for this file.  The DATA INCLUDE file is meant
! to load the COMMON INCLUDE file.

! The following are reserved symbols declared in this INCLUDE file:
!    IRXXN = Reactions index

      DATA  KUNITS /   2 /

      INTEGER IRXXN

      DATA ( KTYPE( IRXXN ), IRXXN = 1, NRXNS ) /
     O      0,    2,    3,    3,    2,    2,    3,    0,    0,    3,
     1      1,    3,    3,    0,    0,    3,    3,    2,    1,    1,
     2      4,    3,    1,    2,    0,    3,    1,    2,    8,    3,
     3      2,    3,    3,    9,    9,    0,    3,    1,    3,    3,
     4      3,    2,    3,    3,    3,    1,    1,    1,    1,    3,
     5      0,    0,    0,    3,    3,    3,    3,    1,    1,    1,
     6      3,    0,    3,    0,    9,    3,    3,    3,    3,    3,
     7      0,    3,    1,    0,    0,    3,    1,    3,    3,    1,
     8      3,    1,    3,    3,    3,    0,    3,    2,    3,    0,
     9      3,    3,    3,    3,    3,    0,    3,    3,    3,    1,
     O      0,    3,    2,    3,    0,    1,    3,    3,    3,    3,
     1      3,    1,    3,    1,    1,    3,    1,    3,    3,    3,
     2      2,    3,    3,    1,    3,    3,    3,    3,    1,    1,
     3      1,    1,    1,    1,    0,    1,    3,    3,    1,    0,
     4      1,    3,    3,    3,    1,    1,    1,    0,    1,    3,
     5      3,    3,    2,    3,    3,    1,    0,    0,    3,    1,
     6      3,    3,    1,    0,    3,    1,    3,    1,    1,    1,
!MONARCH     7      1,    3,    1,    1,    1,    3,    4/
     7      1,    3,    1,    1,    1,    3,    4,    0,    1,    1/
!MONARCH

      DATA ( IRXBITS( IRXXN ), IRXXN = 1, NRXNS ) /
     O      2,  276,    0,    0,    1,    1,    0,    2,    2,  260,
     1      8,    0,    0,    2,    2,    0,    0,    1,    8,    8,
     2      1,   16,    8,    1,    2,    0,    0,    1,    0,    0,
     3      1,    1,    0,    0,    8,    2,    0,  128,  128,    0,
     4      0,    1,    0,    0,    0,    0,    0,    0,    0,    0,
     5      2,    2,    2,    0,    0,    0,    0,    0,    0,    0,
     6      0,    2,    0,    2,    0,   64,    0,    0,    0,    0,
     7      2,    0,    0,    2,    2,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    2,    0,    1,    1,    2,
     9      0,    0,    0,    0,    0,    2,    0,    0,    0,    0,
     O      2,    0,    1,    1,    2,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    2,    0,    0,    0,    0,    2,
     4      0,    0,    0,    0,    0,    0,    0,    2,    0,    0,
     5      0,    0,    1,    0,    0,    0,    2,    2,    0,    0,
     6      0,    0,    0,    2,   64,    0,    0,    0,    0,    0,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( IORDER( IRXXN ), IRXXN = 1, NRXNS ) /
     O      1,    3,    2,    2,    2,    2,    2,    1,    1,    2,
     1      2,    2,    2,    1,    1,    2,    2,    2,    2,    3,
     2      1,    3,    3,    2,    1,    2,    2,    2,    2,    2,
     3      2,    1,    2,    2,    3,    1,    2,    2,    2,    2,
     4      2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
     5      1,    1,    1,    2,    2,    2,    2,    2,    2,    2,
     6      2,    1,    2,    1,    2,    2,    2,    2,    2,    2,
     7      1,    2,    2,    1,    1,    2,    2,    2,    1,    2,
     8      2,    2,    2,    2,    2,    1,    2,    2,    1,    1,
     9      2,    2,    2,    2,    2,    1,    2,    2,    2,    2,
     O      1,    2,    2,    1,    1,    2,    2,    2,    2,    2,
     1      2,    2,    1,    1,    2,    2,    2,    2,    2,    2,
     2      2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
     3      2,    2,    2,    2,    1,    2,    2,    2,    2,    1,
     4      2,    2,    2,    2,    2,    2,    2,    1,    2,    2,
     5      2,    2,    2,    2,    2,    2,    1,    1,    2,    2,
     6      2,    2,    2,    1,    2,    2,    2,    2,    2,    2,
!MONARCH     7      2,    2,    2,    2,    2,    2,    2/
     7      2,    2,    2,    2,    2,    2,    2,    1,    2,    2/
!MONARCH

      DATA ( KRX1( IRXXN ), IRXXN = 1, KTN1 ) /
     &     11,   19,   20,   23,   27,   38,   46,   47,   48,   49,
     &     58,   59,   60,   73,   77,   80,   82,  100,  106,  112,
     &    114,  115,  117,  124,  129,  130,  131,  132,  133,  134,
     &    136,  139,  141,  145,  146,  147,  149,  156,  160,  163,
!MONARCH     &    166,  168,  169,  170,  171,  173,  174,  175/
     &    166,  168,  169,  170,  171,  173,  174,  175,  179,  180/
!MONARCH

      DATA ( KRX2( IRXXN ), IRXXN = 1, KTN2 ) /
     &      2/

      DATA ( KRX3( IRXXN ), IRXXN = 1, KTN3 ) /
     O      3,    4,    7,   10,   12,   13,   16,   17,   22,   26,
     1     30,   33,   37,   39,   40,   41,   43,   44,   45,   50,
     2     54,   55,   56,   57,   61,   63,   66,   67,   68,   69,
     3     70,   72,   76,   78,   79,   81,   83,   84,   85,   87,
     4     91,   92,   93,   94,   95,   97,   98,   99,  102,  107,
     5    108,  109,  110,  111,  113,  116,  118,  119,  120,  122,
     6    123,  125,  126,  127,  128,  137,  138,  142,  143,  144,
     7    150,  151,  152,  154,  155,  159,  161,  162,  165,  167,
     8    172,  176/

      DATA ( KRX4( IRXXN ), IRXXN = 1, KTN4 ) /
     &    177/

      DATA   KRX5( 1 ) / 0 /

      DATA   KRX6( 1 ) / 0 /

      DATA   KRX7( 1 ) / 0 /

      DATA ( NRXWM( IRXXN ), IRXXN = 1, NWM ) /
!MONARCH     &      2,   10/
     &      2,   10,   179/
!MONARCH

      DATA ( NRXWW( IRXXN ), IRXXN = 1, NWW ) /
!MONARCH     &     11,   19,   20,   20,   23,   35/
     &     11,   19,   20,   20,   23,   35,   180/
!MONARCH

      DATA ( NRXWO2( IRXXN ), IRXXN = 1, NWO2 ) /
     &      2,   22/

      DATA   NRXWN2( 1 ) / 0 /

      DATA ( NRXWCH4( IRXXN ), IRXXN = 1, NWCH4 ) /
     &     66,  165/

      DATA ( NRXWH2( IRXXN ), IRXXN = 1, NWH2 ) /
     &     38,   39/

      DATA ( IRR( IRXXN,  1 ), IRXXN = 1, NRXNS ) /
     O      1,    3,    4,    3,    3,    3,    1,    4,    4,    6,
     1      6,    4,    4,    5,    5,    5,    5,    5,    9,    9,
     2      9,    2,    2,    2,   11,    7,   11,    1,    7,    8,
     3      8,   12,    7,    8,    8,   13,    7,    6,    7,    7,
     4      7,    7,    7,    8,   13,    5,    5,    5,    5,    5,
     5     12,   10,    9,   14,   15,   14,   15,   14,   15,   14,
     6     16,   16,   17,   17,    7,    7,   23,   23,   23,   24,
     7     24,   25,   18,   18,   18,   18,   18,   18,   26,   26,
     8     26,   27,   19,   19,   19,   19,   28,   28,   29,   29,
     9     28,   28,   28,   28,   30,   30,   31,   20,   20,   20,
     O     20,   32,   32,   33,   33,   33,   32,   32,   32,   32,
     1     32,   21,   34,   34,   34,    3,    7,    4,    5,    3,
     2      7,    4,    5,   37,   37,   37,   37,   38,   40,   40,
     3      7,   39,   43,   43,   42,   42,   42,    7,    7,   45,
     4      3,    7,    4,    5,    7,    4,    5,   49,   50,   50,
     5     50,   50,   52,    7,    7,    1,   57,   59,   58,   60,
     6     60,   60,    7,   61,   58,   58,   58,   58,   58,   58,
!MONARCH     7     58,   58,   58,   58,   58,   58,   62/
     7     58,   58,   58,   58,   58,   58,   62,    1,   63,   63/
!MONARCH

      DATA ( IRR( IRXXN,  2 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    2,    1,    1,    2,    4,    0,    0,    0,
     1      0,    7,    8,    0,    0,    2,    1,    1,    0,    0,
     2      0,    2,    1,    7,    0,   11,   11,    7,   10,    2,
     3      1,    0,   12,    8,    8,    0,   13,    0,    0,    3,
     4      7,    7,    8,    3,    3,    3,    7,    8,    4,    5,
     5      0,    0,    0,    2,    2,    8,    8,   14,   15,   15,
     6      7,    0,    7,    0,   22,    0,    2,    8,   23,    7,
     7      0,    7,    7,    0,    0,    3,    5,    8,    0,    2,
     8      8,    7,    3,    7,    5,    0,    2,    1,    0,    0,
     9      8,   23,   14,   28,    7,    0,    7,    3,    7,    5,
     O      0,    2,    1,    0,    0,    7,    8,   23,   14,   32,
     1     28,    7,    0,    0,    1,   35,   35,   35,   35,   36,
     2     36,   36,   36,    3,    7,    4,    5,    7,    2,    0,
     3     39,    5,    1,    8,    0,    7,    4,   46,   45,    0,
     4     48,   48,   48,   48,   49,   49,   49,    0,    3,    7,
     5      4,    5,    7,   55,   56,   48,    0,    0,    4,   60,
     6      2,    8,   61,    0,    0,   21,   56,   36,   35,   37,
!MONARCH    7     48,   18,   19,   20,   25,   55,    7/
     7     48,   18,   19,   20,   25,   55,    7,    0,    0,    0/
!MONARCH

      DATA ( IRR( IRXXN,  3 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( IRR( IRXXN,  4 ), IRXXN = 1, NRXNS ) /
     O      2,    4,    1,    2,    5,    1,    5,    3,    6,    3,
     1      7,    8,    7,    1,    2,    1,    2,    9,   10,   10,
     2      5,    1,   11,   11,    2,    1,    2,   10,    5,    7,
     3     12,    8,    1,   13,   13,    7,    8,    7,    8,    8,
     4      3,   13,    0,    7,    7,    1,    8,   10,    1,    1,
     5      8,    7,    1,    1,   16,   17,   17,    0,    0,    0,
     6     10,    1,   14,    7,    8,   23,   18,   24,   18,   23,
     7     18,   18,    8,    8,   22,    7,   10,   26,   18,   27,
     8     24,    8,   28,   28,   28,   23,   23,   29,   28,   28,
     9     30,   23,   23,   23,   28,   23,   23,   32,   32,   32,
     O     23,   19,   33,   32,   32,   19,   30,   19,   19,   19,
     1     23,   14,   14,    8,   16,   19,   18,   19,    1,   18,
     2     14,   18,    1,   19,   19,   19,   19,    8,    1,   39,
     3     43,   43,   16,   39,   28,   14,   20,    8,   14,   28,
     4     49,   49,   49,   49,   21,   28,   20,   22,   20,    8,
     5      7,    1,   53,    8,   19,   49,   58,    7,   60,   57,
     6     58,   59,   58,   58,   62,   62,   62,   61,   61,   62,
!MONARCH     7     62,   62,   62,   62,   62,   62,   58/
     7     62,   62,   62,   62,   62,   62,   58,   63,    1,    7/
!MONARCH

      DATA ( IRR( IRXXN,  5 ), IRXXN = 1, NRXNS ) /
     O      3,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    3,    0,    0,    1,    0,    0,    0,
     2      1,    0,    0,    0,    7,    0,    1,    0,    0,    1,
     3      0,    1,    0,    0,    0,    0,    0,    8,    0,    0,
     4      0,    0,    0,    0,    8,    0,    1,    0,    0,    0,
     5      1,    1,    5,    0,    0,    0,    0,    0,    0,    0,
     6      8,    8,   19,    8,    0,    0,    8,    0,    8,   14,
     7      8,    8,   22,   22,    0,    8,    8,    0,    8,    1,
     8      0,    0,    7,    0,   10,   22,    1,    0,    1,    1,
     9     31,    8,   31,    0,    0,    7,    0,    7,    0,   10,
     O     22,    1,    0,    1,    1,    1,   31,   14,   31,   14,
     1     14,   15,   19,    0,    0,   20,   19,   18,   18,    8,
     2     18,   22,   14,   20,   20,   20,   20,   14,    8,    8,
     3     14,   10,    0,    0,    8,   22,   28,   14,   28,    8,
     4     18,   18,   18,   16,   18,   18,   18,   19,   21,   14,
     5      8,    8,    8,   19,   14,   16,    0,   58,    0,   58,
     6      1,    0,   22,   22,   23,   14,   19,   14,   19,   61,
!MONARCH     7     14,    8,   28,   32,    8,    8,    0/
     7     14,    8,   28,   32,    8,    8,    0,    0,    0,   11/
!MONARCH

      DATA ( IRR( IRXXN,  6 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      7,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6     18,   18,   20,   19,    0,    0,    1,    0,   25,    8,
     7      7,    0,    0,    0,    0,   22,   22,    0,    0,    8,
     8      0,    0,    0,    0,    0,    8,    0,    0,    0,    0,
     9      4,   18,    0,    0,    0,    0,    0,    0,    0,    0,
     O      8,    8,    0,    0,    0,    0,    4,    8,    0,    8,
     1      8,    8,    8,    0,    0,    8,   20,   20,   14,   22,
     2     20,    8,   18,    8,    8,   18,    8,   39,   42,    0,
     3      8,   44,    0,    0,   22,    8,   18,   39,    0,   22,
     4     14,   14,   14,   14,   14,   45,   21,   18,   51,   15,
     5     14,   14,   54,   20,   15,   14,    0,    0,    0,    0,
     6      0,    0,    0,    8,    0,   15,   14,    8,   20,   19,
!MONARCH     7      8,   22,    0,    0,   18,   19,    0/
     7      8,   22,    0,    0,   18,   19,    0,    0,    0,    0/
!MONARCH
      DATA ( IRR( IRXXN,  7 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      5,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6     19,   19,    0,   20,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,   31,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,   14,    0,    0,    0,    0,    0,   31,    0,    0,
     1     19,   19,   21,    0,    0,   14,   14,   14,   15,   14,
     2      8,    7,    0,   14,   14,   22,    1,   40,   16,    0,
     3     42,    0,    0,    0,    0,   28,   14,   45,    0,    0,
     4      8,    8,    8,    8,    8,    8,    8,   21,    0,   18,
     5     15,   15,    0,   18,    8,    8,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    8,   15,   18,   14,   20,
!MONARCH     7     61,    0,    0,    0,    0,    0,    0/
     7     61,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH
      DATA ( IRR( IRXXN,  8 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6     20,   20,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,   18,    0,    0,
     1      0,   21,   15,    0,    0,   22,    8,    7,   20,    7,
     2      0,   27,    0,   22,    0,    3,    0,   41,    0,    0,
     3     44,    0,    0,    0,    0,   18,   22,   21,    0,    0,
     4     32,   15,    7,    1,   22,    7,   22,    8,    0,   21,
     5     18,   20,    0,   14,    0,    2,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,   19,    8,    0,    8,   35,
!MONARCH     7     49,    0,    0,    0,    0,    0,    0/
     7     49,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( IRR( IRXXN,  9 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6     21,   21,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,   34,   34,    0,    0,   18,   21,   22,   19,    0,
     2      0,    0,    0,   21,    0,    7,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    7,   40,    0,    0,
     4     21,    0,   32,   20,   45,   14,   16,   14,    0,   20,
     5     22,   16,    0,    0,    0,   20,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,   21,    0,    0,   21,   21,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH
      DATA ( IRR( IRXXN, 10 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,   20,   20,    0,    0,   15,    0,    8,   21,    0,
     2      0,    0,    0,    0,    0,    8,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    8,   47,    0,    0,
     4      0,    0,   20,   21,   19,   19,   32,   28,    0,   51,
     5     21,   51,    0,    0,    0,   21,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,   34,    0,    0,    0,   14,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( IRR( IRXXN, 11 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,   21,    0,   21,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
     4      0,    0,   21,    0,   28,   21,   14,    0,    0,    0,
     5     20,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,   20,    0,    0,    0,    8,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( IRR( IRXXN, 12 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    7,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,   22,    0,   32,   22,   10,    0,    0,    0,
     5     32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( IRR( IRXXN, 13 ), IRXXN = 1, NRXNS ) /
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     5      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     8      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     9      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     O      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     2      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     3      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     4      0,    0,    0,    0,   20,    0,    0,    0,    0,    0,
     5     51,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     6      0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
!MONARCH     7      0,    0,    0,    0,    0,    0,    0/
     7      0,    0,    0,    0,    0,    0,    0,    0,    0,    0/
!MONARCH

      DATA ( RTDAT( 1,IRXXN ), IRXXN = 1, NRXNS ) /
     O     1.0000D+00, 6.0000D-34, 3.0000D-12, 5.6000D-12, 2.5000D-31,
     +     9.0000D-32, 1.2000D-13, 1.0000D+00, 1.0000D+00, 2.1000D-11,
     1     2.2000D-10, 1.7000D-12, 1.0000D-14, 1.0000D+00, 1.0000D+00,
     +     1.5000D-11, 4.5000D-14, 2.0000D-30, 2.5000D-22, 1.8000D-39,
     2     1.0000D-03, 3.3000D-39, 5.0000D-40, 7.0000D-31, 1.0000D+00,
     +     1.8000D-11, 1.0000D-20, 2.0000D-30, 2.4000D-14, 3.5000D-12,
     3     1.8000D-31, 4.1000D-05, 1.3000D-12, 2.3000D-13, 3.2200D-34,
     +     1.0000D+00, 2.9000D-12, 1.1000D-10, 5.5000D-12, 2.2000D-11,
     4     4.2000D-12, 6.9000D-31, 4.8000D-11, 3.0000D-11, 1.4000D-12,
     +     1.0000D-11, 2.2000D-11, 3.5000D-12, 1.0000D-17, 8.5000D-13,
     5     1.0000D+00, 1.0000D+00, 1.0000D+00, 2.6000D-12, 2.6000D-12,
     +     7.5000D-13, 7.5000D-13, 6.8000D-14, 6.8000D-14, 6.8000D-14,
     6     5.9000D-13, 1.0000D+00, 3.0100D-12, 1.0000D+00, 1.4400D-13,
     +     2.4500D-12, 2.8000D-12, 4.1000D-13, 9.5000D-14, 3.8000D-12,
     7     1.0000D+00, 7.3000D-12, 9.0000D-12, 1.0000D+00, 1.0000D+00,
     +     3.4000D-11, 5.8000D-16, 9.7000D-15, 2.4000D+12, 5.6000D-12,
     8     5.6000D-15, 4.0000D-13, 1.8000D-11, 5.6000D-12, 1.4000D-12,
     +     1.0000D+00, 8.1000D-12, 2.7000D-28, 4.9000D-03, 1.0000D+00,
     9     4.3000D-13, 2.0000D-12, 4.4000D-13, 2.9000D-12, 4.0000D-13,
     +     1.0000D+00, 4.0000D-13, 1.3000D-11, 5.1000D-12, 6.5000D-15,
     O     1.0000D+00, 6.7000D-12, 2.7000D-28, 4.9000D-03, 1.0000D+00,
     +     3.0000D-13, 4.3000D-13, 2.0000D-12, 4.4000D-13, 2.9000D-12,
     1     2.9000D-12, 8.1000D-13, 1.0000D+15, 1.6000D+03, 1.5000D-11,
     +     1.0000D-11, 3.2000D-11, 6.5000D-15, 7.0000D-13, 1.0400D-11,
     2     1.0000D-28, 1.2000D-14, 3.3000D-12, 2.3000D-11, 1.0000D-11,
     +     8.4000D-15, 9.6000D-13, 1.8000D-12, 8.1000D-12, 4.2000D+00,
     3     4.1000D-11, 2.2000D-11, 1.4000D-11, 5.5000D-12, 9.0000D+00,
     +     3.0000D-11, 5.4000D-17, 1.7000D-11, 1.8000D-11, 1.0000D+00,
     4     3.6000D-11, 2.5400D-11, 7.8600D-15, 3.0300D-12, 3.3600D-11,
     +     7.1000D-18, 1.0000D-15, 3.6000D-03, 3.6000D-11, 1.5000D-11,
     5     1.2000D-15, 3.7000D-12, 3.0000D-31, 6.9000D-12, 8.7000D-12,
     +     1.5000D-19, 1.0000D+00, 1.0000D+00, 2.3000D-11, 1.6300D-14,
     6     6.4000D-12, 2.7000D-12, 5.0000D-13, 1.0000D+00, 6.6000D-12,
     +     5.0000D-11, 8.3000D-11, 1.0700D-10, 2.5000D-10, 3.5000D-10,
     7     4.3000D-10, 8.2000D-11, 7.9000D-11, 1.3000D-10, 5.5000D-11,
!MONARCH     +     8.2000D-11, 6.5800D-13/
!     +     8.2000D-11, 6.5800D-13, 1.0000D+00, 2.8000D-11, 1.7000D-13/ !Li et al 2008
!     +     8.2000D-11, 6.5800D-13, 1.0000D+00, 2.8000D-11, 1.2000D-14/ !Crowley and Carl 1997
     +     8.2000D-11, 6.5800D-13, 0.0000D+00, 0.0000D+00, 0.0000D+00/ !deactivated
!MONARCH

      DATA ( RTDAT( 2,IRXXN ), IRXXN = 1, NRXNS ) /
     O     0.0000D+00,-2.4000D+00, 0.0000D+00, 0.0000D+00,-1.8000D+00,
     +    -1.5000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     1     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00,-4.4000D+00, 0.0000D+00, 0.0000D+00,
     2    -3.5000D+00, 0.0000D+00, 0.0000D+00,-2.6000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00,-3.0000D+00, 4.6000D+02, 0.0000D+00,
     3    -3.2000D+00, 0.0000D+00, 0.0000D+00, 6.0000D+02, 2.8000D+03,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     4     0.0000D+00,-1.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     5     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     6     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     7     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     8     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00,-7.1000D+00, 0.0000D+00, 0.0000D+00,
     9     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     O     0.0000D+00, 0.0000D+00,-7.1000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     1     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     2    -8.0000D-01, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     3     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     4     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     5     0.0000D+00, 0.0000D+00,-3.3000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     6     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     7     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
!MONARCH     +     0.0000D+00, 1.1600D+00/
     +     0.0000D+00, 1.1600D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00/
!MONARCH

      DATA ( RTDAT( 3,IRXXN ), IRXXN = 1, NRXNS ) /
     O     0.0000D+00, 0.0000D+00,-1.5000D+03, 1.8000D+02, 0.0000D+00,
     +     0.0000D+00,-2.4500D+03, 0.0000D+00, 0.0000D+00, 1.0200D+02,
     1     0.0000D+00,-9.4000D+02,-4.9000D+02, 0.0000D+00, 0.0000D+00,
     +     1.7000D+02,-1.2600D+03, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     2    -1.1000D+04, 5.3000D+02, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +    -3.9000D+02, 0.0000D+00, 0.0000D+00, 2.7000D-17, 2.5000D+02,
     3     0.0000D+00,-1.0650D+04, 3.8000D+02, 1.7000D-33, 2.3800D-54,
     +     0.0000D+00,-1.6000D+02, 0.0000D+00,-2.0000D+03, 1.2000D+02,
     4    -2.4000D+02, 0.0000D+00, 2.5000D+02, 2.0000D+02,-2.0000D+03,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,-2.4500D+03,
     5     0.0000D+00, 0.0000D+00, 0.0000D+00, 3.6500D+02, 3.6500D+02,
     +     7.0000D+02, 7.0000D+02, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     6    -3.6000D+02, 0.0000D+00, 1.9000D+02, 0.0000D+00, 3.4300D-33,
     +    -1.7750D+03, 3.0000D+02, 7.5000D+02, 3.9000D+02, 2.0000D+02,
     7     0.0000D+00,-6.2000D+02, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +    -1.6000D+03, 0.0000D+00, 6.2500D+02,-7.0000D+03, 0.0000D+00,
     8     2.3000D+03, 0.0000D+00,-1.1000D+03, 2.7000D+02,-1.9000D+03,
     +     0.0000D+00, 2.7000D+02, 0.0000D+00,-1.2100D+04, 0.0000D+00,
     9     1.0400D+03, 5.0000D+02, 1.0700D+03, 5.0000D+02, 2.0000D+02,
     +     0.0000D+00, 2.0000D+02,-8.7000D+02, 4.0500D+02, 0.0000D+00,
     O     0.0000D+00, 3.4000D+02, 0.0000D+00,-1.2100D+04, 0.0000D+00,
     +     0.0000D+00, 1.0400D+03, 5.0000D+02, 1.0700D+03, 5.0000D+02,
     1     5.0000D+02, 0.0000D+00,-8.0000D+03, 0.0000D+00, 0.0000D+00,
     +    -2.8000D+02, 0.0000D+00,-1.9000D+03,-2.1600D+03,-7.9200D+02,
     2     0.0000D+00,-2.6300D+03,-2.8800D+03, 0.0000D+00, 5.5000D+02,
     +    -1.1000D+03,-2.7000D+02, 3.5500D+02, 0.0000D+00, 0.0000D+00,
     3     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     +     0.0000D+00,-5.0000D+02, 1.1600D+02, 0.0000D+00, 0.0000D+00,
     4     0.0000D+00, 4.0760D+02,-1.9120D+03,-4.4800D+02, 0.0000D+00,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00, 4.4900D+02,
     5    -8.2100D+02, 1.7500D+02, 0.0000D+00,-2.3000D+02,-1.0700D+03,
     +     0.0000D+00, 0.0000D+00, 0.0000D+00,-2.0000D+02, 0.0000D+00,
     6     2.9000D+02, 2.2000D+02, 0.0000D+00, 0.0000D+00,-1.2400D+03,
     +     0.0000D+00,-1.0000D+02, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     7     0.0000D+00,-3.4000D+01, 0.0000D+00, 0.0000D+00, 0.0000D+00,
!MONARCH     +     4.5000D+01, 5.8000D+01/
     +     4.5000D+01, 5.8000D+01, 0.0000D+00, 0.0000D+00, 0.0000D+00/
!MONARCH

      DATA ( IRRFALL( IRXXN ), IRXXN = 1, NFALLOFF ) /
     &      5,    6,   18,   21,   24,   28,   29,   31,   32,   34,
     &     35,   42,   65,   88,   89,  103,  104,  121,  153/

      DATA ( RFDAT( 1,IRXXN ), IRXXN = 1, NFALLOFF ) /
     &     2.2000D-11, 3.0000D-11, 1.4000D-12, 9.7000D+14, 3.6000D-11,
     &     2.5000D-11, 2.1990D+03, 4.7000D-12, 4.8000D+15, 1.0000D+03,
     &     3.2000D+03, 2.6000D-11, 0.0000D+00, 1.2000D-11, 5.4000D+16,
     &     1.2000D-11, 5.4000D+16, 8.8000D-12, 1.5000D-12/

      DATA ( RFDAT( 2,IRXXN ), IRXXN = 1, NFALLOFF ) /
     &    -7.0000D-01, 0.0000D+00,-7.0000D-01, 1.0000D-01,-1.0000D-01,
     &     0.0000D+00, 6.5000D-34, 0.0000D+00, 0.0000D+00, 0.0000D+00,
     &     0.0000D+00, 0.0000D+00, 0.0000D+00,-9.0000D-01, 0.0000D+00,
     &    -9.0000D-01, 0.0000D+00, 0.0000D+00, 0.0000D+00/

      DATA ( RFDAT( 3,IRXXN ), IRXXN = 1, NFALLOFF ) /
     &     0.0000D+00, 0.0000D+00, 0.0000D+00,-1.1080D+04, 0.0000D+00,
     &     0.0000D+00, 1.3350D+03, 0.0000D+00,-1.1170D+04, 0.0000D+00,
     &     0.0000D+00, 0.0000D+00, 0.0000D+00, 0.0000D+00,-1.3830D+04,
     &     0.0000D+00,-1.3830D+04, 0.0000D+00, 0.0000D+00/

      DATA ( RFDAT( 4,IRXXN ), IRXXN = 1, NFALLOFF ) /
     &     6.0000D-01, 6.0000D-01, 6.0000D-01, 4.5000D-01, 6.0000D-01,
     &     6.0000D-01, 0.0000D+00, 6.0000D-01, 6.0000D-01, 0.0000D+00,
     &     0.0000D+00, 6.0000D-01, 0.0000D+00, 3.0000D-01, 3.0000D-01,
     &     3.0000D-01, 3.0000D-01, 6.0000D-01, 6.0000D-01/

      DATA ( RFDAT( 5,IRXXN ), IRXXN = 1, NFALLOFF ) /
     &     1.0000D+00, 1.0000D+00, 1.0000D+00, 1.0000D+00, 1.0000D+00,
     &     1.0000D+00, 0.0000D+00, 1.0000D+00, 1.0000D+00, 0.0000D+00,
     &     0.0000D+00, 1.0000D+00, 0.0000D+00, 1.0000D+00, 1.0000D+00,
     &     1.0000D+00, 1.0000D+00, 1.0000D+00, 1.0000D+00/

      DATA ( SC( IRXXN,  1 ), IRXXN = 1, NRXNS ) /
     O        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     1        2.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        2.00000,    1.00000,    1.00000,    2.00000,    2.00000,
     2        1.00000,    2.00000,    2.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     3        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        2.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     4        1.00000,    1.00000,    0.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    2.00000,
     5        0.61000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     6        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.37000,    0.70000,
     7        1.00000,    1.00000,    1.00000,    2.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     8        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     9        0.80000,    0.90000,    0.90000,    2.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     O        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    0.80000,    0.90000,    0.90000,    2.00000,
     1        1.00000,    0.87000,    0.96000,    1.00000,    1.00000,
     +        0.20000,    0.80000,    0.18000,    1.00000,    1.00000,
     2        1.00000,    1.00000,    1.00000,    1.24000,    1.30000,
     +        0.65000,    1.18000,    0.44000,    0.90000,    1.00000,
     3        0.40000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    0.03000,    0.70000,    1.00000,    1.00000,
     4        0.75000,    0.91200,    0.65000,    0.20000,    1.56500,
     +        0.11400,    0.35700,    0.33300,    0.15000,    0.75000,
     5        0.57000,    0.47000,    1.00000,    1.00000,    0.99100,
     +        0.20000,    2.00000,    1.00000,    1.00000,    0.30000,
     6        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
     +        1.00000,    1.00000,    1.00000,    1.00000,    0.30000,
     7        0.15000,    1.00000,    1.00000,    1.00000,    1.00000,
!MONARCH     +        1.00000,    1.00000/
     +        1.00000,    1.00000,    1.00000,    1.00000,    1.00000/
!MONARCH

      DATA ( SC( IRXXN,  2 ), IRXXN = 1, NRXNS ) /
     O        1.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    1.00000,
     1        0.00000,    0.00000,    0.00000,    1.00000,    0.00000,
     +        0.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     2        1.00000,    0.00000,    0.00000,    0.00000,    1.00000,
     +        0.00000,    1.00000,    0.00000,    0.00000,    1.00000,
     3        0.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    1.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    1.00000,
     +        0.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     5        0.61000,    1.00000,    1.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        1.00000,    1.00000,    0.50000,    1.00000,    0.00000,
     +        0.00000,    1.00000,    0.00000,    0.74000,    0.30000,
     7        1.00000,    1.00000,    1.00000,    1.00000,    0.00000,
     +        1.00000,    1.00000,    0.00000,    1.00000,    1.00000,
     8        0.00000,    0.00000,    1.00000,    0.00000,    1.00000,
     +        1.00000,    1.00000,    0.00000,    1.00000,    1.00000,
     9        0.20000,    0.90000,    0.10000,    0.00000,    0.00000,
     +        1.00000,    0.00000,    1.00000,    0.00000,    1.00000,
     O        1.00000,    1.00000,    0.00000,    1.00000,    1.00000,
     +        1.00000,    0.20000,    0.90000,    0.10000,    2.00000,
     1        1.00000,    0.13000,    0.60000,    0.00000,    0.00000,
     +        0.30000,    0.33000,    0.74000,    1.00000,    1.70000,
     2        1.56000,    0.63000,    1.00000,    0.66000,    0.70000,
     +        0.35000,    0.64000,    0.08000,    0.90000,    1.00000,
     3        0.60000,    1.00000,    0.00000,    0.00000,    1.00000,
     +        2.00000,    0.62000,    0.50000,    1.00000,    1.00000,
     4        0.50000,    0.62900,    0.60000,    0.80000,    0.16700,
     +        0.15000,    0.28200,    0.06700,    5.12000,    1.25000,
     5        0.07000,    0.28000,    1.00000,    0.90000,    0.99100,
     +        0.80000,    0.00000,    1.00000,    0.00000,    1.40000,
     6        1.00000,    0.00000,    1.00000,    1.00000,    1.00000,
     +        0.87000,    0.99100,    2.00000,    0.33000,    0.70000,
     7        1.00000,    1.00000,    1.00000,    1.00000,    1.00000,
!MONARCH     +        1.00000,    0.00000/
     +        1.00000,    0.00000,    0.00000,    0.00000,    1.00000/
!MONARCH

      DATA ( SC( IRXXN,  3 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.39000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.33000,    0.33000,    0.50000,    0.50000,    0.00000,
     +        0.00000,    1.00000,    0.00000,    0.63000,    0.30000,
     7        1.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        1.00000,    1.00000,    0.00000,    0.00000,    1.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        1.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.20000,    1.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        1.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.20000,    1.00000,    0.00000,    2.00000,
     1        1.00000,    0.11000,    0.94000,    0.00000,    0.00000,
     +        0.30000,    0.62000,    0.32000,    0.91000,    1.00000,
     2        0.22000,    0.13000,    2.00000,    0.10000,    1.00000,
     +        0.25000,    1.00000,    0.36000,    0.90000,    0.00000,
     3        0.60000,    1.00000,    0.00000,    0.00000,    1.00000,
     +        2.00000,    0.70000,    0.20000,    0.00000,    1.00000,
     4        0.25000,    0.99100,    0.20000,    1.00000,    0.71300,
     +        0.85000,    1.28200,    0.90000,    1.00000,    0.25000,
     5        0.76000,    1.03000,    1.00000,    0.05000,    0.00900,
     +        1.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    1.00000,    0.00000,
     +        0.13000,    0.99100,    1.00000,    0.67000,    0.45000,
     7        1.00000,    1.00000,    0.00000,    0.00000,    1.00000,
!MONARCH     +        1.00000,    0.00000/
     +        1.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN,  4 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.39000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.33000,    0.33000,    0.00000,    0.50000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.10000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.10000,    0.00000,    0.00000,
     1        1.00000,    0.06000,   -2.10000,    0.00000,    0.00000,
     +        0.20000,    0.80000,    0.22000,    0.09000,    0.70000,
     2        1.00000,    0.13000,    0.00000,    0.10000,    1.00000,
     +        0.25000,    1.00000,    0.56000,    0.10000,    0.00000,
     3        0.30000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        1.00000,    0.03000,    0.80000,    0.00000,    0.00000,
     4        0.25000,    0.91200,    0.06600,    0.80000,    0.50300,
     +        0.15400,    0.92500,    0.83200,    0.00000,    0.28000,
     5        0.18000,    0.25000,    0.00000,    0.10000,    1.00000,
     +        0.80000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.11000,    0.00900,    1.00000,    2.00000,    0.55000,
     7        0.85000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN,  5 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.33000,    0.33000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.10000,    0.00000,    0.00000,
     1        0.00000,   -0.11000,    0.04000,    0.00000,    0.00000,
     +        0.20000,    0.95000,    0.10000,    0.56000,    0.30000,
     2        0.00000,    0.37000,    0.00000,    0.10000,    0.00000,
     +        0.50000,    0.00000,    1.00000,    0.00000,    0.00000,
     3        1.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        1.00000,    0.69000,    1.10000,    0.00000,    0.00000,
     4        0.25000,    0.08800,    0.26600,    0.20000,    0.33400,
     +        0.26800,    0.64300,    1.03300,    0.00000,    1.66000,
     5        0.24000,    0.47000,    0.00000,    0.10000,    0.00000,
     +        0.20000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.06000,    1.00000,    0.00000,    1.00000,    0.30000,
     7        1.00000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN,  6 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6       -0.66000,   -0.66000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.76000,    0.02000,    0.00000,    0.00000,
     +        0.20000,   -0.70000,    0.33000,    0.35000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.10000,    0.00000,
     +        0.50000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.08000,    0.30000,    0.00000,    0.00000,
     4        0.25000,    0.00000,    0.20000,    0.80000,    0.16800,
     +        0.06400,    0.85000,    0.70000,    0.00000,    0.47000,
     5        0.00100,    0.53000,    0.00000,    0.00000,    0.00000,
     +        0.80000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +       -0.11000,    0.00000,    0.00000,   -1.00000,    0.30000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN,  7 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.05000,    0.50000,    0.00000,    0.00000,
     +        0.01000,    0.00000,    0.44000,   -1.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.50000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.76000,    1.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.15000,    2.40000,    0.25200,
     +        0.02000,    0.07500,    0.96700,    0.00000,    1.00000,
     5        7.00000,    1.00000,    0.00000,    0.00000,    0.00000,
     +        2.40000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.76000,    0.00000,    0.00000,    0.00000,    1.70000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN,  8 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.20000,    0.00000,   -1.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.20000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.35000,    0.00000,    0.21000,
     +        0.36000,    0.07500,    0.00000,    0.00000,    0.00000,
     5        0.21000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.05000,    0.00000,    0.00000,    0.00000,    1.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN,  9 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.10000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.06600,    0.00000,    0.25000,
     +        0.22500,    0.15000,    0.00000,    0.00000,    0.00000,
     5        0.39000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( SC( IRXXN, 10 ), IRXXN = 1, NRXNS ) /
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     8        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     9        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     O        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     1        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     2        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     3        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     4        0.00000,    0.00000,    0.00000,    0.00000,    0.12000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     5        1.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     6        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
     7        0.00000,    0.00000,    0.00000,    0.00000,    0.00000,
!MONARCH     +        0.00000,    0.00000/
     +        0.00000,    0.00000,    0.00000,    0.00000,    0.00000/
!MONARCH

      DATA ( NREACT( IRXXN ), IRXXN = 1, NRXNS ) /
     O      1,    1,    2,    2,    2,    2,    2,    1,    1,    1,
     1      1,    2,    2,    1,    1,    2,    2,    2,    1,    1,
     2      1,    2,    2,    2,    1,    2,    2,    2,    2,    2,
     3      2,    1,    2,    2,    2,    1,    2,    1,    1,    2,
     4      2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
     5      1,    1,    1,    2,    2,    2,    2,    2,    2,    2,
     6      2,    1,    2,    1,    2,    1,    2,    2,    2,    2,
     7      1,    2,    2,    1,    1,    2,    2,    2,    1,    2,
     8      2,    2,    2,    2,    2,    1,    2,    2,    1,    1,
     9      2,    2,    2,    2,    2,    1,    2,    2,    2,    2,
     O      1,    2,    2,    1,    1,    2,    2,    2,    2,    2,
     1      2,    2,    1,    1,    2,    2,    2,    2,    2,    2,
     2      2,    2,    2,    2,    2,    2,    2,    2,    2,    1,
     3      2,    2,    2,    2,    1,    2,    2,    2,    2,    1,
     4      2,    2,    2,    2,    2,    2,    2,    1,    2,    2,
     5      2,    2,    2,    2,    2,    2,    1,    1,    2,    2,
     6      2,    2,    2,    1,    1,    2,    2,    2,    2,    2,
!MONARCH     7      2,    2,    2,    2,    2,    2,    2/
     7      2,    2,    2,    2,    2,    2,    2,    1,    1,    1/
!MONARCH

      DATA ( NPRDCT( IRXXN ), IRXXN = 1, NRXNS ) /
     O      2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
     1      1,    1,    1,    2,    1,    1,    2,    1,    1,    1,
     2      2,    1,    1,    1,    2,    1,    2,    1,    1,    2,
     3      1,    2,    1,    1,    1,    1,    1,    2,    1,    1,
     4      1,    1,    0,    1,    2,    1,    2,    1,    1,    1,
     5      4,    2,    2,    1,    1,    1,    1,    0,    0,    0,
     6      6,    6,    3,    4,    1,    1,    3,    1,    3,    3,
     7      3,    2,    2,    2,    1,    3,    3,    1,    2,    3,
     8      1,    1,    2,    1,    2,    3,    2,    1,    2,    2,
     9      3,    4,    2,    1,    1,    2,    1,    2,    1,    2,
     O      3,    4,    1,    2,    2,    2,    3,    5,    2,    3,
     1      4,    7,    7,    1,    1,    9,    6,    8,    7,    5,
     2      4,    5,    3,    6,    4,    7,    4,    5,    4,    2,
     3      5,    3,    1,    1,    3,    5,    8,    7,    2,    3,
     4      6,    5,    9,    7,   10,    9,    9,    7,    3,    7,
     5     10,    7,    3,    5,    4,    7,    1,    2,    1,    2,
     6      2,    1,    2,    3,    2,    8,    5,    4,    6,    8,
!MONARCH     7      5,    3,    2,    2,    3,    3,    1/
     7      5,    3,    2,    2,    3,    3,    1,    1,    1,    2/
!MONARCH

      DATA ( IPH( IRXXN,1 ), IRXXN = 1, NMPHOT ) /
     &      1,    8,    9,   14,   15,   25,   36,   51,   52,   53,
     &     62,   64,   71,   74,   75,   86,   90,   96,  101,  105,
!MONARCH     &    135,  140,  148,  157,  158,  164/
     &    135,  140,  148,  157,  158,  164,  178/
!MONARCH

      DATA ( IPH( IRXXN,2 ), IRXXN = 1, NMPHOT ) /
     &      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     &     11,   12,   12,   13,   14,   15,   16,   17,   18,   16,
!MONARCH     &     13,   19,   20,   21,   22,   23/
     &     13,   19,   20,   21,   22,   23,   24/
!MONARCH

      DATA ( IPH( IRXXN,3 ), IRXXN = 1, NMPHOT ) /
     &      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     &     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
!MONARCH     &     21,   22,   23,   24,   25,   26/
     &     21,   22,   23,   24,   25,   26,   27/
!MONARCH

      DATA ( PHOTAB( IRXXN ), IRXXN = 1, NPHOTAB ) /
     &   'NO2_SAPRC99     ', 'O3_O3P_IUPAC04  ', 'O3_O1D_IUPAC04  ',
     &   'NO3NO2_SAPRC99  ', 'NO3NO_SAPRC99   ', 'HONO_IUPAC04    ',
     &   'H2O2_SAPRC99    ', 'HO2NO2_IUPAC04  ', 'HNO3_IUPAC04    ',
     &   'N2O5_IUPAC04    ', 'NTR_IUPAC04     ', 'COOH_SAPRC99    ',
     &   'HCHO_R_SAPRC99  ', 'HCHO_M_SAPRC99  ', 'CCHO_R_SAPRC99  ',
     &   'PAN_IUPAC04     ', 'PACD_CB05       ', 'C2CHO_SAPRC99   ',
     &   'MGLY_IUPAC04    ', 'ACROLEIN_SAPRC99', 'CL2_IUPAC04     ',
!MONARCH     &   'HOCL_IUPAC04    ', 'FMCL_IUPAC04    '/
     &   'HOCL_IUPAC04    ', 'FMCL_IUPAC04    ', 'NO2E_IUPAC04    '/
!MONARCH

      DATA ( RXLABEL( IRXXN ), IRXXN = 1, NRXNS ) /
     O    'R1              ', 'R2              ', 'R3              ',
     1    'R4              ', 'R5              ', 'R6              ',
     2    'R7              ', 'R8              ', 'R9              ',
     3    'R10             ', 'R11             ', 'R12             ',
     4    'R13             ', 'R14             ', 'R15             ',
     5    'R16             ', 'R17             ', 'R18             ',
     6    'R19             ', 'R20             ', 'R21             ',
     7    'R22             ', 'R23             ', 'R24             ',
     8    'R25             ', 'R26             ', 'R27             ',
     9    'R28             ', 'R29             ', 'R30             ',
     O    'R31             ', 'R32             ', 'R33             ',
     1    'R34             ', 'R35             ', 'R36             ',
     2    'R37             ', 'R38             ', 'R39             ',
     3    'R40             ', 'R41             ', 'R42             ',
     4    'R43             ', 'R44             ', 'R45             ',
     5    'R46             ', 'R47             ', 'R48             ',
     6    'R49             ', 'R50             ', 'R51             ',
     7    'R52             ', 'R53             ', 'R54             ',
     8    'R55             ', 'R56             ', 'R57             ',
     9    'R58             ', 'R59             ', 'R60             ',
     O    'R61             ', 'R62             ', 'R63             ',
     1    'R64             ', 'R65             ', 'R66             ',
     2    'R67             ', 'R68             ', 'R69             ',
     3    'R70             ', 'R71             ', 'R72             ',
     4    'R73             ', 'R74             ', 'R75             ',
     5    'R76             ', 'R77             ', 'R78             ',
     6    'R79             ', 'R80             ', 'R81             ',
     7    'R82             ', 'R83             ', 'R84             ',
     8    'R85             ', 'R86             ', 'R87             ',
     9    'R88             ', 'R89             ', 'R90             ',
     O    'R91             ', 'R92             ', 'R93             ',
     1    'R94             ', 'R95             ', 'R96             ',
     2    'R97             ', 'R98             ', 'R99             ',
     3    'R100            ', 'R101            ', 'R102            ',
     4    'R103            ', 'R104            ', 'R105            ',
     5    'R106            ', 'R107            ', 'R108            ',
     6    'R109            ', 'R110            ', 'R111            ',
     7    'R112            ', 'R113            ', 'R114            ',
     8    'R115            ', 'R116            ', 'R117            ',
     9    'R118            ', 'R119            ', 'R120            ',
     O    'R121            ', 'R122            ', 'R123            ',
     1    'R124            ', 'R125            ', 'R126            ',
     2    'R127            ', 'R128            ', 'R129            ',
     3    'R130            ', 'R131            ', 'R132            ',
     4    'R133            ', 'R134            ', 'R135            ',
     5    'R136            ', 'R137            ', 'R138            ',
     6    'R139            ', 'R140            ', 'R141            ',
     7    'R142            ', 'R143            ', 'R144            ',
     8    'R145            ', 'R146            ', 'R147            ',
     9    'R148            ', 'R149            ', 'R150            ',
     O    'R151            ', 'R152            ', 'R153            ',
     1    'R154            ', 'R155            ', 'R156            ',
     2    'CL1             ', 'CL2             ', 'CL3             ',
     3    'CL4             ', 'CL5             ', 'CL6             ',
     4    'CL7             ', 'CL8             ', 'CL9             ',
     5    'CL10            ', 'CL11            ', 'CL12            ',
     6    'CL13            ', 'CL14            ', 'CL15            ',
     7    'CL16            ', 'CL17            ', 'CL18            ',
!MONARCH     8    'CL19            ', 'CL20            ', 'CL21            '/
     8    'CL19            ', 'CL20            ', 'CL21            ',
     9    'R178            ', 'R179            ', 'R180            '/
!MONARCH

! End of Mechanism Reactions, Rates, etc. DATA INCLUDE File ------------


      END MODULE RXCM
