!
!-----------------------------------------------------------------------
!***  llgrid_chem.inc - for wrf/gfs input grid - START
!-----------------------------------------------------------------------

!-----------------------------------------------------------------------
!***  input grid boundaries
!-----------------------------------------------------------------------
!
      parameter
     &(bowest_ch=304.875,bosout_ch=16.875                   !<-- turn positive summing 360
     &,boeast_ch=439.875,bonort_ch=76.5                      !<-- gdas.ONEDEG / gfs.ONEDEG.inputdata
     &,delon_ch=1.125,delat_ch=1.125)                                                !<-- gdas.ONEDEG / gfs.ONEDEG.inputdata
!
!-----------------------------------------------------------------------
!***  input grid coordinates
!-----------------------------------------------------------------------
!
      parameter
     &(imll_chem=(boeast_ch-bowest_ch)/delon_ch+1
     &,jmll_chem=(bonort_ch-bosout_ch)/delat_ch+1         !<-- gdas.ONEDEG / gfs.ONEDEG / wafs.0P5DEG.inputdata
     &,lmll_chem=54) 

!-----------------------------------------------------------------------

      integer, parameter:: n_pol=10     !num of pollutants for use in boundary conditions+pressure            

      parameter
     &(tboco_ch=3                                                        !<-- update every 6  hours (input)
     &,nhours_ch=21)                                                       !<-- length of chemistry forecast (input)
     
    
      integer, parameter:: t_chem= nhours_ch/tboco_ch+1    !number of chemistry data (input)


!!! Pollutants used in boundary conditions

      
       
      character*10, dimension(n_pol-1) :: name_pol


!      name_pol(1)='NO2'
!      name_pol(2)='NO'
!      name_pol(3)='O3'
!      name_pol(4)='HNO3'
!      name_pol(5)='H2O2'
!      name_pol(6)='CH2O' !FORM
!      name_pol(7)='CO'
!      name_pol(8)='PAN'
!      name_pol(9)='SO2'


!
!-----------------------------------------------------------------------
!***  llgrid_chem.inc - END
!-----------------------------------------------------------------------
